#include <actor_graphic_menu_bar.hpp>
#include <actor_graphic_2D_panel.hpp>
#include <event_loop_manager_qt.hpp>
#include <pixel_converter_qt.hpp>


class Listener : public bicotiListenerMenu
{
public:
  bicotiEventLoopManagerQT * ptr_app;
  bicotiActorGraphicMenuPopup * ptr_popup;
  
  void ItemSelected( bicotiActor * ptr_act, char * item )
    {cout << "Se selecciono: " << ptr_act->GetActorDescriptor().GetActorName() << ", item: " << item << "." << endl;
    
    if( !strcmp( item, "Quit" ) )
      ptr_app->Stop();
    
    if( !strcmp( item, "Remove Item1" ) )
      {ptr_popup->RemoveElement( 3 );
      cout << "Borrando" << endl;}}
};


void main( int argc, char ** argv )
{
  bicotiActorGraphic2DPanel panel;

  bicotiActorGraphicMenuPopup opop( "Menu Popup" );
  opop.AddItem( "Subtem1" );
  opop.AddItem( "Subtem2" );
  opop.AddItem( "Subtem3" );
  
  bicotiActorGraphicMenuPopup pop( "Menu Popup" );
  pop.AddItem( "Item1" );
  pop.AddItem( "Item2" );
  pop.AddItem( "Item3" );
  pop.AddSeparator();
  pop.AddItem( "Otro Popup" , &opop );
  
  bicotiActorGraphicMenuBar menu( "Menu Bar" );
  
  menu.AddItem( "File", &pop );
  menu.AddSeparator();
  menu.AddItem( "Remove Item1" );
  menu.AddItem( "Quit" );

  Listener list;
  
  cout << endl;

  menu.AddListenerMenu( &list, "File" );
  menu.AddListenerMenu( &list, "Remove Item1" );
  menu.AddListenerMenu( &list, "Quit" );

  pop.AddListenerMenu( &list, "Item1" );
  pop.AddListenerMenu( &list, "Item2" );
  pop.AddListenerMenu( &list, "Item3" );

  opop.AddListenerMenu( &list, "Subtem1" );

  panel.SetChild( &menu );
  panel.SetSize( 750, 30 );
  
  bicotiEventLoopManagerQT event_loop( argc, argv );
  panel.SetMainActor( true );

  bicotiHomologousFactoryQT< unsigned char, bicotiPixelConverterChar2QRGB > factory;
 
  panel.SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 0, 128, 0 ) );
  
  factory.CreateHomologous( &opop );
  factory.CreateHomologous( &pop );

  factory.RecursiveCreateHomologous( &panel );
  panel.SetPosition( 100, 100 );
  list.ptr_app = &event_loop;
  list.ptr_popup = &pop;
  
  event_loop.Start();
}  
