#include <actor_graphic_menu_bar.hpp>
#include <actor_graphic_2D_panel.hpp>
#include <event_loop_manager_qt.hpp>
#include <pixel_converter_qt.hpp>


bicotiHomologousFactoryQT< unsigned char, bicotiPixelConverterChar2QRGB > factory;

class Listener : public bicotiListenerMenu
{
public:
  bicotiEventLoopManagerQT * ptr_app;
  bicotiActorGraphicMenuBar * mbr;
  bicotiActorGraphicMenuPopup * menup;
  
  void ItemSelected( bicotiActor * ptr_act, char * item )
    {cout << "Se selecciono " << item << endl;
    
    if( !strcmp( item, "Quit" ) )
      ptr_app->Stop();
    
    if( !strcmp( item, "Pop" ) )
      {factory.CreateHomologous( menup );
      menup->SetVisible( false );
      mbr->AddItem( "Popup", menup );}}
};


void main( int argc, char ** argv )
{
  bicotiActorGraphic2DPanel panel;
  bicotiActorGraphicMenuBar menu( "MenuBar" );

  menu.AddItem( "Item1" );
  menu.AddItem( "Item2" );
  menu.AddItem( "Item3" );
  menu.AddItem( "Item4" );
  menu.AddItem( "Pop" );
  menu.AddItem( "Quit" );
  menu.AddSeparator();

  Listener list;
  menu.AddListenerMenu( &list, "Item1" );
  menu.AddListenerMenu( &list, "Item2" );
  menu.AddListenerMenu( &list, "Item3" );
  menu.AddListenerMenu( &list, "Item4" );
  menu.AddListenerMenu( &list, "Pop" );
  menu.AddListenerMenu( &list, "Quit" );

  list.mbr = &menu;

  bicotiActorGraphicMenuPopup menup( "MenuPup" );
  menup.AddItem( "Popup1" );
  menup.AddItem( "Popup2" );
  
  list.menup = &menup;
  
  panel.SetChild( &menu );
  panel.SetSize( 750, 30 );

  bicotiEventLoopManagerQT event_loop( argc, argv );
  panel.SetMainActor( true );

 
  panel.SetBackgroundColor( bicotiRGBTools :: CreateRGBA( 0, 128, 0 ) );
  factory.RecursiveCreateHomologous( &panel );
  panel.SetPosition( 100, 100 );
  list.ptr_app = &event_loop;
  
  event_loop.Start();
}  
