#ifndef _menu_manager
#define _menu_manager


#include <actor_graphic_menu_bar.hpp>
#include <actor_graphic_2D_file_dialog.hpp>
#include "basic_settings.hpp"


class MainWindow;


class MenuManager : public bicotiListenerMenu, public bicotiListenerFileDialog
{
private:
  bicotiActorGraphicMenuBar * ptr_menu_main;
  bicotiActorGraphicMenuPopup * ptr_menu_file;
  bicotiActorGraphicMenuPopup * ptr_menu_perfil;
  bicotiActorGraphicMenuPopup * ptr_menu_edit_points;
  bicotiActorGraphicMenuPopup * ptr_menu_interpolator;

  bicotiActorGraphic2DFileDialog * ptr_file_dialog;

  CurrentImageType :: HomologousFactory factory;
  
  MainWindow * ptr_main_window;
  
  static const int file_dialog_width = 600;
  static const int file_dialog_height = 350;
  
public:
  MenuManager( MainWindow * );
  ~MenuManager();
  
  bicotiActorGraphicMenuBar * GetMainMenu();

  void ItemSelected( bicotiActor *, char * );

  void FileDialogFileSelected( bicotiActor *, const char * );
  void FileDialogFileHighlighted( bicotiActor * , const char * );
  void FileDialogDirectoryChanged( bicotiActor * , const char * );
};



#endif
