#include <coordinate.hpp>


/* Ejemplo de uso de coordenadas vectoriales dinmicas en bicoti. */


void main()
{
  cout << endl << endl;
  cout << "_________________________________________________________________" << endl;
  cout << " Las coordenadas vectoriales dinmicas, al igual que las 2D o 3D" << endl;
  cout << "pueden crearse con componentes de cualquier tipo." << endl;
  cout << " En el constructor hay que pasar la dimensin de la coordenada." << endl << endl;;
  cout << "\t  bicotiCoordinate< int > coord1( 2 );" << endl;
  cout << "\t  bicotiCoordinate< float > coord2( 3 );" << endl << endl;
  cout << " coord1 es una coordenada de enteros con dos componentes" << endl;
  cout << " coord2 por su parte es una coordenada de flotantes con tres componentes" << endl << endl;

  bicotiCoordinate< int > coord1( 2 );
  bicotiCoordinate< float > coord2( 3 );

  cout << " En el siguiente caso creamos coord3 con los mismos valores " << endl;
  cout << "y dimension de coord1." << endl;
  cout << " Para ello usamos el constructor de copia." << endl << endl;
  cout << "\t bicotiCoordinate< int > coord3( coord1 );" << endl << endl;

  bicotiCoordinate< int > coord3( coord1 );

  cout << " Tambien es posible no asignar la dimensin en el momento de la construccin." << endl;
  cout << " Este constructor por defecto pone la dimensin en cero." << endl << endl;
  cout << "\t bicotiCoordinate< float > coord4;" << endl << endl;

  bicotiCoordinate< float > coord4;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();

  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  
  cout << " El operador de asigancin en la coordenada dinmica, no solo copia" << endl;
  cout << "las componentes, tambin cambia la dimensin de la coordenada." << endl << endl;
  cout << "\t coord4 = coord2;" << endl << endl;

  coord4 = coord2;

  cout << " Cabe aclarar que todos los operadores de coordenada funcionan entre" << endl;
  cout << "objetos del mismo tipo. En particular no podra haber ejecutado" << endl << endl;
  cout << "\t coord4 = coord1;" << endl << endl;
  cout << "ya que las componentes de ambos son de tipos distintos." << endl << endl;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();
  
  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " La nica forma de acceder a las componentes es usando la interface" << endl;
  cout << "estndar de las coordenadas." << endl << endl;

  cout << "\t coord2( 0 ) = 1;" << endl;
  cout << "\t coord2( 1 ) = 2;" << endl;
  cout << "\t coord2( 2 ) = -1;" << endl << endl;
  
  coord2( 0 ) = 1;
  coord2( 1 ) = 2;
  coord2( 2 ) = -1;

  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " , " << coord2( 2 ) << " )" << endl << endl;

  cout << "\t coord3( 0 ) = 0;" << endl;
  cout << "\t coord3( 1 ) = 3;" << endl << endl;
  
  coord3( 0 ) = 0;
  coord3( 1 ) = 3;
  
  cout << ">> coord3 = ( " << coord3( 0 ) << " , " << coord3( 1 ) << " )" << endl << endl;

  cout << " Como siempre es posible consultar la dimensin de una coordenada." << endl << endl;
  cout << "\t cout << \"La dimensin de coord3 es \" << coord3.GetDimension() << endl;" << endl << endl;
  cout << ">> La dimensin de coord3 es " << coord3.GetDimension() << endl << endl;

  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get();

  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Es posible usar todos los operadores como en 2 o 3D." << endl;
  cout << " Tanto las dimensiones como el tipo de componente deben coincidir" << endl << endl;
  
  cout << "\t coord1 = coord3 + 1;" << endl << endl;
  coord1 = coord3 + 1;
  cout << ">> coord3 = ( " << coord3( 0 ) << " , " << coord3( 1 ) << " )" << endl;
  cout << ">> coord1 = ( " << coord1( 0 ) << " , " << coord1( 1 ) << " )" << endl << endl;
  
  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << " , " << coord4( 2 ) << " )" << endl << endl;
  cout << "\t coord4 = coord2 + coord4;" << endl << endl;
  coord4 = coord2 + coord4;
  cout << ">> coord2 = ( " << coord2( 0 ) << " , " << coord2( 1 ) << " , " << coord2( 2 ) << " )" << endl;
  cout << ">> coord4 = ( " << coord4( 0 ) << " , " << coord4( 1 ) << " , " << coord4( 2 ) << " )" << endl << endl;
};
