#include <image_2D_array_char.hpp>
#include <actor_image_2D_double_qt.hpp>
#include <mapper.hpp>


typedef double PixT;
typedef bicotiCoordinate2D< REAL > CoordT;
typedef bicotiImageImplementation2DArray< PixT > ImaT;
 
void MostrarCoord( CoordT coord )
{
  cout<<" ( "<<coord.X0()<<" , "<<coord.X1()<<" ) "<<endl;
};

void main( int argc, char ** argv )   
{  
  CoordT aux_coord, coord_pto, temp_coord; 
  ImaT * ptr_ima;  
  ptr_ima = new ImaT( 0, 0, 0 );
  
  bicotiDeviceFile device( "../Pictures/black.jpg" );
  bicotiMapperJPEGIJG< PixT, bicotiPixelConverterDouble2RGBA > mapper;
  mapper.SetDevice( &device );
  mapper.SetImplementation( ptr_ima );
  mapper.Read();
  
  vector< CoordT > list_coords; 
  vector< CoordT > list_coords_recta( 2 );
  vector< CoordT > list_coords_normal( 2 );
   
  unsigned opcion; 

  cout << endl; 
  cout << "----------------------- Seleccione el interpolador ----------------" << endl; 
  cout << "-Tener en cuenta que la curvatura en el interpolador lineal es inf-" << endl;
  cout << " 1 -> Lineal" << endl; 
  cout << " 2 -> Simpson" << endl; 
  cout << " 3 -> Spline" << endl; 
  cout << " Opcion :"; 
  cin >> opcion; 
  cout << "-------------------------------------------------------------------" << endl; 
 
  //-------- Cargo la curva ------------ 
  // una cfa
 
  unsigned index_1, num_ptos; 
  double ang, radio = 100; 
  CoordT punto, centro; 
 
  cout << "Numero de puntos de la cfa : "; 
  cin >> num_ptos; 
  cout << "---------------------------------------------" << endl; 
 
  centro.X0() = 200; 
  centro.X1() = 200; 
 
  for ( index_1 = 0 ; index_1 < num_ptos; index_1 ++ ) 
    {ang = 2 * pi * index_1 / num_ptos; 
    punto.X0() = radio * cos( ang ); 
    punto.X1() = radio * sin( ang ); 
    punto = centro + punto; 
    list_coords.push_back( punto );}
  //------------------------------------ 
   
  //-- Creo interpoladores y Dexels ---- 
 
  bicotiCoordinateInterpolator1DClosed< CoordT > * ptr_coord_int; 
 
  if ( opcion == 1 ) 
    { ptr_coord_int = new bicotiCoordinateInterpolator1DClosedLinear< CoordT >;} 
  else 
    {if ( opcion == 2 ) 
      { ptr_coord_int = new bicotiCoordinateInterpolator1DClosedSimpson< CoordT >;} 
    else 
      {ptr_coord_int = new bicotiCoordinateInterpolator1DClosedSpline< CoordT >;}}; 
 
 
  bicotiImagePixelInterpolator< PixT > * ptr_pixel_int;
  ptr_pixel_int = new bicotiImagePixelInterpolator2DLinear< PixT >; 
   
  bicotiDexelCurveClosed< CoordT, PixT > * ptr_curve; 
  ptr_curve = new bicotiDexelCurveClosed< CoordT, PixT >( ptr_ima , list_coords, ptr_coord_int, ptr_pixel_int );
   
  bicotiCurveProperties< CoordT, PixT > proper( ( bicotiDexelCurve< CoordT, PixT > * )ptr_curve );
 
   
  //-------Ingreso un valor------------ 

  double offset; 
 
  cout << "----- Seleccione el offset de un punto ------" << endl;
  cout << "offset[0,1] t = "; 
  cin >> offset; 
   
  aux_coord = proper.GetTangent( offset ); 
  coord_pto = (*ptr_curve)( offset ); 
   
  cout << "Punto : "; 
  MostrarCoord( coord_pto ); 
  cout << "Vector Tangente : T(t) = "; 
  MostrarCoord( aux_coord ); 
  cout << " -> Modulo : "; 
  cout << aux_coord.Norm()<<endl;
  cout << "Curvatura : k(t) = "; 
  cout << proper.GetCurvature( offset )<<endl;
  cout << "Vector Normal : N(t) = "; 
  temp_coord = proper.GetNormal( offset ); 
  MostrarCoord( temp_coord ); 
  cout << " -> Modulo : "; 
  cout << temp_coord.Norm()<<endl; 
   
   
  //----------Creo las rectas----------- 
  double Knor = 50; 
 
  list_coords_recta[ 0 ] = coord_pto - ( aux_coord * Knor ); 
  list_coords_recta[ 1 ] = coord_pto + ( aux_coord * Knor ); 
   
  list_coords_normal[ 0 ] = coord_pto - ( temp_coord * Knor ); 
  list_coords_normal[ 1 ] = coord_pto + ( temp_coord * Knor ); 
 
  bicotiCoordinateInterpolator1DOpen< CoordT > * ptr_recta_int; 
 
  ptr_recta_int = new bicotiCoordinateInterpolator1DOpenLinear< CoordT >; 
 
  bicotiDexelCurveOpen< CoordT, PixT > * ptr_recta; 
  ptr_recta = new bicotiDexelCurveOpen< CoordT, PixT >( ptr_ima , list_coords_recta, ptr_recta_int, ptr_pixel_int ); 
 
  bicotiCoordinateInterpolator1DOpen< CoordT > * ptr_normal_int; 
  ptr_normal_int = new bicotiCoordinateInterpolator1DOpenLinear< CoordT >; 
 
  bicotiDexelCurveOpen< CoordT, PixT > * ptr_normal; 
  ptr_normal = new bicotiDexelCurveOpen< CoordT, PixT >( ptr_ima , list_coords_normal, ptr_normal_int, ptr_pixel_int ); 
 
  //----------Escribo en la imagen------------- 
  unsigned index_3; 
  const unsigned points = 1000; 
  const REAL step = 1.0 / points; 
   
  for( index_3 = 0 ; index_3 < points ; index_3 ++ ) 
    {ptr_curve->SetPixel( step * index_3, 255 ); 
    ptr_recta->SetPixel( step * index_3, 255 ); 
    ptr_normal->SetPixel( step * index_3, 255 );}; 
 
  ptr_curve->UpdateImageImplementation(); 
  ptr_recta->UpdateImageImplementation(); 
  ptr_normal->UpdateImageImplementation(); 
   
  bicotiActorImage2DDoubleQT actor;
  actor.GetImplementation()->CopyMeFrom( ptr_ima );
  bicotiActorImage2DDoubleQT :: HomologousFactory factory;
  bicotiActorImage2DDoubleQT :: EventLoopManager event_loop( argc, argv );
  actor.GetActor()->SetMainActor( true );
  actor.GetActor()->SetSize( actor.GetImplementation()->GetX0Size(), actor.GetImplementation()->GetX1Size() );
  factory.CreateHomologous( actor.GetActor() );
  event_loop.Start();

  //------------Borrandoooooooo!!!!!---------- 
  delete ptr_curve; 
  delete ptr_recta; 
  delete ptr_normal; 
  delete ptr_pixel_int; 
  delete ptr_recta_int; 
  delete ptr_normal_int; 
  delete ptr_coord_int; 
  delete ptr_ima;
} 
   
