#include <image_2D_array_char.hpp>
#include <actor_image_2D_char_qt.hpp>

typedef unsigned char PixelType; 
typedef REAL PrecisionType; 
typedef bicotiCoordinate3D<INTEGER> CoordType; 
 
void main(int argc , char ** argv) 
{ 
  
  bicotiImageImplementation3DArray< PixelType > imagen_3d( 128, 256, 256, 256); 
  unsigned i,j,k; 
  for( i = 0; i < 256 ; i++) 
    for( j = 0; j < 256 ; j++) 
     for( k = 0; k < 256 ; k++) 
       imagen_3d.SetPixel( i, j, k, j); 
  
  
  bicotiGeometricalFacade3D< PixelType, PrecisionType > facade3D( &imagen_3d ); 
  bicotiImageImplementation2DArray< PixelType > imag( 0 ); 
  bicotiCoordinate3D< REAL > point_1( 0, 15, 0), point_2( 0, 15, 255), point_3( 255, 250, 0); 
  
  
  facade3D.UsePixelInterpolatorLinear(); 
  
  facade3D.BuildCutter( point_1, point_2, point_3, &imag); 
  
  cout << "Origen = " << facade3D.GetOriginSubspace().X0()  << '\t' << facade3D.GetOriginSubspace().X1() << '\t'   << facade3D.GetOriginSubspace().X2() << endl; 
  cout << "Vector I = " << facade3D.GetVectorISubspace().X0() << '\t' << facade3D.GetVectorISubspace().X1() << '\t' << facade3D.GetVectorISubspace().X2() << endl; 
  cout << "Vector J = " << facade3D.GetVectorJSubspace().X0() << '\t' << facade3D.GetVectorJSubspace().X1() << '\t' << facade3D.GetVectorJSubspace().X2() << endl; 
  
  bicotiActorImage2DCharQT actor;
  actor.GetImplementation()->CopyMeFrom(( bicotiImageImplementation2DArray< PixelType > *)( facade3D.GetResult() ));
  actor.GetActor()->SetSize( actor.GetImplementation()->GetX0Size(), actor.GetImplementation()->GetX1Size() );
  bicotiActorImage2DCharQT :: HomologousFactory factory;
  bicotiActorImage2DCharQT :: EventLoopManager event_loop( argc, argv );
  actor.GetActor()->SetMainActor( true );
  factory.CreateHomologous( actor.GetActor() );
  event_loop.Start();
 }
