#include <actor_image_2D_rgb_char_qt.hpp> 

/* 
   El ejemplo consiste en una rotacion de centro (100,100),(columnas,filas) y  
   angulo 45 grados antihorario. 
   
   Leo de disco una imagen unsigned char( grises ) y la cargo en ima1. 
   Muestro en pantalla la imagen 
   Construyo la fachada de geometrical desde la fachada de imagen. 
   Construyo una transformacion afin. 
   Construyo la rotacion dando el angulo. 
   Seteo el centro de rotacion; uso interpolador de lagrange. 
   Aplico la transformacion afin( donde la rotacion es un caso particular). 
   Muestro resultado en pantalla. 
   Destruyo la fachada de geometrical.  
*/

typedef bicotiActorImage2DRGBCharQT ImaT; 
typedef ImaT::Implementation ImpT;

void main( int argc, char ** argv ) 
{    
  ImaT ima1;

  ima1.BuildMapper();
  ima1.GetMapper()->BuildDeviceFile( "rotacion.jpg" );
  ima1.GetMapper()->BuildMapperJPEGIJG();
  ima1.GetMapper()->Read();
  ima1.GetActor()->SetSize( ima1.GetImplementation()->GetX0Size(), ima1.GetImplementation()->GetX1Size() );

  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  
  ima1.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima1.GetActor() );

  event_loop.Start();
  ima1.GetActor()->DestroyHomologous();

  ima1.BuildGeometrical(); 

  ( ima1.GetGeometrical() )->BuildAffimTransformation(); 
  bicotiCoordinate2D< REAL > centro(100,100); 
  ( ima1.GetGeometrical() )->RotationCenter() = centro; 
  ( ima1.GetGeometrical() )->BuildRotation( pi/4 ); 
  ( ima1.GetGeometrical() )->UsePixelInterpolatorLinear();       
  ( ima1.GetGeometrical() )->ApplyAffimTransformation( true ); 
  ima1.LoadGeometricalResult();
  ima1.GetActor()->SetSize( ima1.GetImplementation()->GetX0Size(), ima1.GetImplementation()->GetX1Size() );
  
  ima1.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima1.GetActor() );
  event_loop.Start();
  
  ima1.DestroyGeometrical(); 
} 

