#include <actor_image_2D_rgb_char_qt.hpp> 
 
/* 
   Este ejemplo comprime a la cuarta parte la imagen original. 
   
   Leo de disco una imagen RGB de unsigned char y la cargo en ima1. 
   Muestro en pantalla la imagen. 
   Construyo la fachada de geometrical desde la fachada de imagen. 
   Creo Matriz y Vector del la transformacion afin. 
   Construyo una transformacion afin. 
   Seteo a la fachada de geometrical Matrix, Vector; uso interpolador de lagrange. 
   Aplico la transformacion afin. 
   Muestro resultado en pantalla. 
   Destruyo la fachada de geometrical.   
*/

typedef bicotiActorImage2DRGBCharQT ImaT; 
typedef ImaT::Implementation ImpT;

void main( int argc, char ** argv ) 
{    
  ImaT ima1; 

  ima1.BuildMapper();
  ima1.GetMapper()->BuildDeviceFile( "zoom.jpg" );
  ima1.GetMapper()->BuildMapperJPEGIJG();
  ima1.GetMapper()->Read();
  ima1.GetActor()->SetSize( ima1.GetImplementation()->GetX0Size(), ima1.GetImplementation()->GetX1Size() );

  bicotiActorImage2DRGBCharQT :: HomologousFactory factory;
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
  
  ima1.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima1.GetActor() );

  event_loop.Start();
  ima1.GetActor()->DestroyHomologous();

  ima1.BuildGeometrical(); 
  
  bicotiMatrix2D< double > matri(0,2,2); 
  matri(0,0)= 1.5; 
  matri(1,1)= 1.5; 
  bicotiCoordinate2D< REAL > punti(0,0); 
  ( ima1.GetGeometrical() )->BuildAffimTransformation(); 
  ( ima1.GetGeometrical() )->Matrix()=matri; 
  ( ima1.GetGeometrical() )->Vector()=punti; 
  ( ima1.GetGeometrical() )->UsePixelInterpolatorLagrange();
  ( ima1.GetGeometrical() )->ApplyAffimTransformation( true ); 
  ima1.LoadGeometricalResult();
  ima1.GetActor()->SetSize( ima1.GetImplementation()->GetX0Size(), ima1.GetImplementation()->GetX1Size() );
 
  ima1.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima1.GetActor() );
  event_loop.Start();

  ima1.DestroyGeometrical(); 
} 

