//************************************************************************
//* Este archivo contiene algunos ejemplos de las diferentes estrategias *
//* de extrapolacin de imagenes                                         *
//************************************************************************  

#include "basic_fun.hpp"  

void main()
{
  unsigned filas = 4, columnas = 5;
  unsigned borde = 2;
  unsigned filas_des;
  unsigned columnas_des;
  float escala = 1;
  int default_pixel = 9;
  int ext_pix = 0;
  int option;
  
  cout << " La siguiente aplicacin crea imgenes con los tamaos elejidos por" << endl;
  cout << "el usuario y luego muestra grficamente cual es el resultado de" << endl;
  cout << "la extrapolacin elejida por el usuario." << endl;
  cout << " No elija imgenes grandes, ya que estas se mostrarn como caracteres" << endl;
  cout << "en pantalla. Los puntos se setean al azar" << endl;

  cout << "================================================================" << endl;
  cout << "Ingrese la cantidad de FILAS de la imagen original : ";
  cin >> filas;
  cout << "Ingrese la cantidad de COLUMNAS de la imagen original : ";
  cin >> columnas;
  cout << "Ingrese la cantidad de pixeles del BORDE de la imagen a extrapolar : ";
  cin >> borde;

  cout << endl << "Primeramente creo una imagen 2D Array de enteros." << endl << endl;
  cout << "\t bicotiImageImplementation2DArray< int > * ptr_ima_src;" << endl;
  cout << "\t ptr_ima_src = new bicotiImageImplementation2DArray< int >(default_pixel , columnas , filas , escala , single);" << endl << endl;

  bicotiImageImplementation2DArray< int > * ptr_ima_src;
  ptr_ima_src = new bicotiImageImplementation2DArray< int >(default_pixel , columnas , filas , escala , single);

  cout << "Ahora creo una imagen 2D Array de enteros ms grande, con borde" << endl << endl;
  cout << "\t filas_des = filas + 2 * borde;" << endl;
  cout << "\t columnas_des = columnas + 2 * borde;" << endl;
  cout << "\t bicotiImageImplementation2DArray< int > * ptr_ima_des;" << endl;
  cout << "\t ptr_ima_des = new bicotiImageImplementation2DArray< int >(default_pixel , columnas_des , filas_des, escala , single);" << endl << endl;

  filas_des = filas + 2 * borde;
  columnas_des = columnas + 2 * borde;

  bicotiImageImplementation2DArray< int > * ptr_ima_des;
  ptr_ima_des = new bicotiImageImplementation2DArray< int >(default_pixel , columnas_des , filas_des, escala , single);
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cin.get();
  cout << endl;

  cout<<"================================================================"<<endl;
  cout<<" Estrategia de extrapolacin "<<endl;
  cout<<" 1 - Constant"<<endl;
  cout<<" 2 - Equal"<<endl;
  cout<<" 3 - Simetric"<<endl;
  cout<<" 4 - Ciclic"<<endl;
  cout<<"Ingrese su opcion : ";
  cin>>option;


  cout << "Creo la estrategia de acuerdo a la opcin" << endl << endl;

  cout << "\t bicotiImageExtrapolationStrategy2D< int > * ptr_ext_strat;" << endl;

  bicotiImageExtrapolationStrategy2D< int > * ptr_ext_strat;

  switch ( option ){
  case 1 :
    cout<<"Ingrese el valor del pixel del borde : ";
    cin>>ext_pix;
    cout << "\t ptr_ext_strat = new bicotiImageExtrapolationStrategy2DConstant< int >(ext_pix);" << endl << endl;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DConstant< int >(ext_pix);
    break;
  case 2:
    cout << "\t ptr_ext_strat = new bicotiImageExtrapolationStrategy2DEqual< int >;" << endl << endl;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DEqual< int >;
    break;
  case 3:
    cout << "\t ptr_ext_strat = new bicotiImageExtrapolationStrategy2DSimetric< int >;" << endl << endl;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DSimetric< int >;
    break;
  case 4:
    cout << "\t ptr_ext_strat = new bicotiImageExtrapolationStrategy2DCiclic< int >;" << endl << endl;
    ptr_ext_strat = new bicotiImageExtrapolationStrategy2DCiclic< int >;
  };
  
  cout << " Asocio la imagen a la estrategia" << endl << endl;
  cout << "\t ptr_ext_strat->SetImplementation(ptr_ima_src);" << endl << endl;
  ptr_ext_strat->SetImplementation(ptr_ima_src);
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cin.get();
  cout << endl;

  cout<<"================================================================"<<endl;
  cout << " Le seteo valores aleatorios a la original y luego la muestro." << endl;
  // Show y SetRand son funciones auxiliares includas en basic_fun.hpp ( NO SON PARTE DE BICOTI )
  SetRand( ptr_ima_src );
  Show( ptr_ima_src , " Imagen Original");

  cout << "Cargo la nueva imagen a travs de la estrategia y la muestro." << endl << endl;

  cout << "\t unsigned i,j;" << endl;
  cout << "\t for ( i = 0 ; i < filas_des ; i++ )" << endl;
  cout << "\t   for ( j = 0 ; j < columnas_des ; j++ )" << endl;
  cout << "\t    ptr_ima_des->SetPixel( j, i, (*ptr_ext_strat)( j - borde, i - borde ) );" << endl << endl;

  unsigned i,j;
  for ( i = 0 ; i < filas_des ; i++ )
    for ( j = 0 ; j < columnas_des ; j++ )
      ptr_ima_des->SetPixel( j, i, (*ptr_ext_strat)( j - borde, i - borde ) );
  
  cout<<endl;
  // Show es una funcin auxiliar includa en basic_fun.hpp ( NO ES PARTE DE BICOTI )
  Show( ptr_ima_des , " Imagen Extrapolada");  

  delete ptr_ima_src;
  delete ptr_ima_des;
  delete ptr_ext_strat;
}

