//************************************************************************
//* Este archivo contiene algunos ejemplos de la flexibilidad que nos    *
//* permiten las estrategias de recorrido para movernos sobre una imagen *
//* con un iterador.                                                     *
//************************************************************************  

#include "basic_fun.hpp"  

void main()
{
  cout << " Este archivo contiene algunos ejemplos de la flexibilidad que nos" << endl;
  cout << "permiten las estrategias de recorrido para movernos sobre una imagen" << endl;
  cout << "con un iterador." << endl << endl;
  
  cout << " Primeramente creo una imagen 2D Array de enteros" << endl << endl;

  cout << "\t unsigned filas = 6, columnas = 4;" << endl;
  cout << "\t float escala = 1;" << endl;
  cout << "\t int default_pixel = 0;" << endl;
  cout << "\t bicotiImageImplementation2DArray< int > * ptr_ima;" << endl;
  cout << "\t ptr_ima = new bicotiImageImplementation2DArray< int >(default_pixel , columnas , filas , escala , single);" << endl << endl;

  unsigned filas = 6, columnas = 4;
  float escala = 1;
  int default_pixel = 0;

  bicotiImageImplementation2DArray< int > * ptr_ima;
  ptr_ima = new bicotiImageImplementation2DArray< int >(default_pixel , columnas , filas , escala , single);

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;

  cout << " Le seteo valores aleatorios y luego la muestro." << endl << endl;
  SetRand( ptr_ima );
  Show( ptr_ima , " Imagen ");

  cout << "Ahora creo un iterador para esta imagen." << endl << endl;

  cout << "\t bicotiImageIterator2DArray< int > * ptr_iterator;" << endl;
  cout << "\t ptr_iterator = (bicotiImageIterator2DArray< int > * ) ptr_ima->CreateIterator();" << endl << endl;

  bicotiImageIterator2DArray< int > * ptr_iterator;
  ptr_iterator = (bicotiImageIterator2DArray< int > * ) ptr_ima->CreateIterator();

  cout << " Hay que hacer un casting porque la funcin CreateIterator devuelve un " << endl;
  cout << "puntero a la clase base." << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << " Recorremos la imagen de la forma mas usaual y vemos la salida." << endl;
  cout << " NOTA: por defecto step = 1 " << endl;

  cout << endl;
  cout << "Recorrido por defecto. De izquierda a derecha bajando." << endl;
  cout << "step = 1 en x0" << endl << endl;
  cout << "\t for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); (*ptr_iterator)++ )" << endl;
  cout << "\t cout << (**ptr_iterator) << \" \";" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); (*ptr_iterator)++ )
    cout << (**ptr_iterator)<<" ";
  cout << endl << endl;

  cout << "De derecha a izquierda subiendo." << endl;
  cout << "step = 1 en x0" << endl << endl;
  cout << "\t for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); (*ptr_iterator)-- )" << endl;
  cout << "\t cout << (**ptr_iterator) << \" \";" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); (*ptr_iterator)-- )
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << " Defino una nueva estrategia con step = 2 en x0 y se la asigno al iterador" << endl;
  cout << "me voy a saltear una fila." << endl << endl;

  cout << "\t bicotiImageBorderStrategy2DX0<int> x0_strat(2);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX0( x0_strat );" << endl << endl;

  bicotiImageBorderStrategy2DX0<int> x0_strat(2);
  ptr_iterator->UseBorderStrategyX0( x0_strat );

  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); (*ptr_iterator)++ )
    cout << (**ptr_iterator) << " ";
  cout << endl;
  
  cout << endl;
  cout << "De derecha a izquierda subiendo, fila por medio." << endl;
  cout<< "step = 2 en x0" << endl << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); (*ptr_iterator)-- )
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << " Le cambio el paso a la estrategia , pongo step = 0" << endl;
  cout << "solo una fila" << endl << endl;
  
  cout << "\t x0_strat.UseStep(0);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX0( x0_strat );" << endl << endl;

  x0_strat.UseStep(0);
  ptr_iterator->UseBorderStrategyX0( x0_strat );

  cout << "De izquierda a derecha bajando, solo una fila." << endl;
  cout << "step = 0 en x0" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); (*ptr_iterator)++ )
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout<<endl;
  cout << "De derecha a izquierda subiendo, solo una fila." << endl;
  cout << "step = 0 en x0" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); (*ptr_iterator)-- )
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << " Ahora pongo step = -1 y hago el recorrido de abajo hacia arriba" << endl << endl;
  
  cout << "\t x0_strat.UseStep(-1);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX0( x0_strat );" << endl;

  x0_strat.UseStep(-1);
  ptr_iterator->UseBorderStrategyX0( x0_strat );

  cout << endl;
  cout << " De izquierda a derecha subiendo."<<endl;
  cout << "step = -1 en x0" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Locate(0,filas-1) ; !(ptr_iterator->IsDone()); (*ptr_iterator)++ )
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;
  
  cout << "De derecha a izquierda bajando." << endl;
  cout << "step = -1 en x0" << endl;
  cout << endl;
  
  cout << ">> ";
  for ( ptr_iterator->Locate(columnas-1,0) ; !(ptr_iterator->IsDone()); (*ptr_iterator)-- )
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;
  
  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << endl << "Recorrida vertical." << endl;
  cout << "por defecto step = 1" << endl;

  cout << endl;
  cout << "Recorrido vertical por defecto. Bajando, de izquierda a derecha." << endl;
  cout << "step = 1 en x1" << endl;
  cout << endl;

  cout << "\t for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Increment())" << endl;
  cout << "\t   cout << (**ptr_iterator) << \" \";" << endl;
  cout << "\t cout << endl;" << endl << endl;

  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Increment())
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout << endl;
  cout << "Subiendo, de derecha a izquierda." << endl;
  cout << "step = 1 en x1" << endl;
  cout << endl;
  
  cout << "\t for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Decrement())" << endl;
  cout << "\t   cout << (**ptr_iterator) << \" \";" << endl;
  cout << "\t cout << endl;" << endl << endl;
  
  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Decrement())
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout << endl << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << "Recorrida vertical, columna por medio" << endl;
  cout << "step = 2 en x1" << endl << endl;
  
  cout << "\t bicotiImageBorderStrategy2DX1<int> x1_strat(2);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX1( x1_strat );" << endl << endl;

  bicotiImageBorderStrategy2DX1<int> x1_strat(2);
  ptr_iterator->UseBorderStrategyX1( x1_strat );

  cout << endl;
  cout << "Bajando de izquierda a derecha. Columna por medio" << endl;
  cout << "step = 2 en x1" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Increment())
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout << endl;
  cout << "Subiendo, de derecha a izquierda.Columna por medio" << endl;
  cout << "step = 2 en x1" << endl;
  cout << endl << endl;

  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Decrement())
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;

  cout << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");


  cout << "Recorrida vertical, solo una columna" << endl;
  cout << "step = 0 en x1" << endl << endl;

  cout << "\t x1_strat.UseStep(0);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX1( x1_strat );" << endl;

  x1_strat.UseStep(0);
  ptr_iterator->UseBorderStrategyX1( x1_strat );

  cout << endl;
  cout << "Bajando. Una sola columna" << endl;
  cout << "step = 0 en x1" << endl;
  cout << endl;
  
  cout << ">> ";
  for ( ptr_iterator->First() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Increment())
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout << endl;
  cout << "Subiendo. Una sola columna" << endl;
  cout << "step = 0 en x1" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Last() ; !(ptr_iterator->IsDone()); ptr_iterator->X1Decrement())
    cout << (**ptr_iterator) << " ";
  cout << endl;


  cout << endl << "PRESIONE ENTER" << endl;
  cin.get();
  cout << endl;
  cout << "---------------------------------------------------------" << endl;
  Show( ptr_ima , " Imagen ");

  cout << "Ahora pongo step = -1 y hago el recorrido de izquierda a derecha." << endl << endl;
  
  cout << "\t x1_strat.UseStep(-1);" << endl;
  cout << "\t ptr_iterator->UseBorderStrategyX1( x1_strat );" << endl;

  x1_strat.UseStep(-1);
  ptr_iterator->UseBorderStrategyX1( x1_strat );

  cout << endl;
  cout << "Bajando, de derecha a izquierda" << endl;
  cout << "step = -1 en x1" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Locate(columnas-1,0) ; !(ptr_iterator->IsDone()); ptr_iterator->X1Increment())
    cout << (**ptr_iterator) << " ";
  cout << endl;

  cout << endl << "Subiendo, de izquierda a derecha" << endl;
  cout << "step = -1 en x1" << endl;
  cout << endl;

  cout << ">> ";
  for ( ptr_iterator->Locate(0,filas-1) ; !(ptr_iterator->IsDone()); ptr_iterator->X1Decrement())
    cout << (**ptr_iterator) << " ";
  cout << endl << endl;

  delete ptr_ima;
};

