#include <actor_image_2D_double_qt.hpp>

typedef bicotiActorImage2DDoubleQT ImaT;

void main( int argc, char ** argv )
{ 
  cout << "El siguiente es un ejemplo de uso para NeighbourFilters" << endl;
  cout << "a travs de fachadas" << endl << endl;

  cout << "Comenzaremos definiendo la imagen y leyndola del disco" << endl << endl;

  unsigned frame_size = 3;
  
  cout << "\t bicotiImage2DArrayFloat ima;" << endl << endl;

  ImaT ima;
  ima.BuildMapper();
  ima.GetMapper()->BuildDeviceFile( "nfilter1.jpg" );
  ima.GetMapper()->BuildMapperJPEGIJG();
  ima.GetMapper()->Read();
  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );

  cout << endl;
  cout << "--------------------------------------------------------------" << endl;
  cout << endl;

  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
  ima.GetActor()->SetMainActor( true );
  factory.CreateHomologous( ima.GetActor() );
  event_loop.Start();

  cout << "Creo la Fachada del filtro." << endl;
  cout << "Declaro un puntero a la fachada." << endl;
  cout << "(esto es solo por comodidad, para no escribir ima.GetNeighbourFilter())" << endl << endl;
  
  cout << "\t ima.BuildNeighbourFilter();" << endl;
  cout << "\t bicotiImage2DArrayFloat::NeighbourFilter * ptr_filt;" << endl;
  cout << "\t ptr_filt = ima.GetNeighbourFilter();" << endl << endl;

  cout << "Creo un filtro lineal." << endl;
  cout << "Le seteo valores al Kernel." << endl << endl;

  cout << "\t ptr_filt->BuildLinearFilter( frame_size );" << endl;
  cout << "\t (*(ptr_filt->GetKernel()))(0,1)=-0.5;" << endl;
  cout << "\t (*(ptr_filt->GetKernel()))(2,1)=0.5;" << endl;
  cout << "\t (*(ptr_filt->GetKernel()))(1,0)=-0.5;" << endl;
  cout << "\t (*(ptr_filt->GetKernel()))(1,2)=0.5;" << endl << endl;
  
  cout << "Con estos valores del kernel el filtro es una implementacin" << endl;
  cout << "en diferencias centradas de la derivada horizontal." << endl;
  cout << "Fijo la estrategia de extrapolacin." << endl << endl;

  cout << "\t ptr_filt->UseExtrapolationStrategyEqual();" << endl << endl;

  cout << "Aplico el Filtro." << endl << endl;

  cout << "\t ptr_filt->Filter();" << endl << endl;

  cout << "Cargo el resultado en la imagen actual." << endl;
  cout << "Borro la fachada del filtro" << endl;
  cout << "Obs : NO borrar ptr_filt, porque la funcin Destroy lo hizo" << endl << endl;

  cout << "\t ima.LoadNeighbourFilterResult();" << endl;
  cout << "\t ima.DestroyNeighbourFilter();" << endl;

  ima.BuildNeighbourFilter();
  ImaT :: NeighbourFilter * ptr_filt;
  ptr_filt = ima.GetNeighbourFilter();
  ptr_filt->BuildLinearFilter( frame_size );
  (*(ptr_filt->GetKernel()))(0,1)=-0.5;
  (*(ptr_filt->GetKernel()))(2,1)=0.5;
  (*(ptr_filt->GetKernel()))(1,0)=-0.5;
  (*(ptr_filt->GetKernel()))(1,2)=0.5;
  ptr_filt->UseExtrapolationStrategyEqual();
  ptr_filt->Filter();
  ima.LoadNeighbourFilterResult();
  ima.DestroyNeighbourFilter();

  cout << endl;
  cout << "--------------------------------------------------------------" << endl;
  cout << endl;

  ima.GetActor()->SetMainActor( true );
  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );

  factory.CreateHomologous( ima.GetActor() );
  event_loop.Start();
  
  cout << "La saturacin en la imagen se debe a la presencia de valores negativos" << endl << endl;

  cout << "Voy a calcular el valor absoluto de la imagen, para eso uso el " << endl;
  cout << "OperatorUnary asociado a la imagen." << endl << endl;

  cout << "\t ima.BuildOperatorUnary();" << endl;
  cout << "\t ima.GetOperatorUnary()->AbsoluteValue();" << endl;
  cout << "\t ima.DestroyOperatorUnary();" << endl;

  ima.BuildOperatorUnary();
  ima.GetOperatorUnary()->AbsoluteValue();
  ima.DestroyOperatorUnary();

  cout << endl;
  cout << "--------------------------------------------------------------" << endl;
  cout << endl;

  ima.GetActor()->SetSize( ima.GetImplementation()->GetX0Size(), ima.GetImplementation()->GetX1Size() );
  ima.GetActor()->RefreshImage(); // PA PROBAR
  ima.GetActor()->SetVisible( true );
  event_loop.Start();
};
