#include <actor_image_2D_char_qt.hpp>
#include <histogram_painter.hpp>
#include <iostream.h>
 
 
typedef bicotiActorImage2DCharQT ImaT;
typedef bicotiHistogramPainter< ImaT :: Pixel > HisT;
 
main( int argc, char ** argv )  
{  
  ImaT imagen;
  imagen.BuildMapper();
  imagen.GetMapper()->BuildDeviceFile( "histo1.jpg" );
  imagen.GetMapper()->BuildMapperJPEGIJG();
  imagen.GetMapper()->Read();
  imagen.GetActor()->SetSize( imagen.GetImplementation()->GetX0Size(), imagen.GetImplementation()->GetX1Size() );
  imagen.DestroyMapper();
  
  ImaT :: HomologousFactory factory;
  ImaT :: EventLoopManager event_loop( argc, argv );
   
  imagen.GetActor()->SetMainActor( true );
  factory.CreateHomologous( imagen.GetActor() );

  imagen.BuildProperty();
  imagen.GetProperty()->BuildHistogramExtended();
  
  HisT hist_tool;
  HisT :: actor_histogram histograma( 0, 612, 300 );
  histograma.SetSize( histograma.GetX0Size(), histograma.GetX1Size() );
  hist_tool.SetActorImage( &histograma );
  hist_tool.SetPropertyHistogram( imagen.GetProperty()->GetHistogram() );
  
  bicotiVerticalStrategyLinear vert_strat;
  bicotiHorizontalStrategyLinear< ImaT :: Pixel > horiz_strat;
  horiz_strat.SetRange( 255 );
  bicotiColorStrategyConstant< ImaT :: Pixel, ImaT :: Pixel > color_strat;
  color_strat.SetPencil( 255 );
  
  hist_tool.AddLayoutInformation( &vert_strat, &horiz_strat, &color_strat, 50, 50, 562, 250 );

  hist_tool.PaintSolid();
  hist_tool.PaintAxes( 255 );
  
  factory.CreateHomologous( &histograma );

  event_loop.Start(); 
  histograma.SetVisible( false );

  imagen.GetProperty()->EqualizateHistogramUniform();
  imagen.GetActor()->SetVisible( true );
  imagen.GetActor()->RefreshImage();
  
  histograma.Resize( 612, 300 );  
  hist_tool.PaintBar();
  hist_tool.PaintAxes( 255 ); 
  histograma.RefreshImage();
  histograma.SetVisible( true );

  event_loop.Start(); 
}     
 



