#include <source/actor/actor_basic.hpp>
#include <source/event_loop_manager/event_loop_manager.hpp>


//------------------IMPLEMENTATIONS--------------------
//----------------bicotiActorDescriptor----------------
bicotiActorDescriptor :: bicotiActorDescriptor( char * act_name, ActorTypes act_type, DimensionCases act_dim, ActorCases act_case )
{
  actor_name = act_name;
  actor_type = act_type;
  dimension_case = act_dim;
  actor_case = act_case;
}

void bicotiActorDescriptor :: operator=( const bicotiActorDescriptor& actor )
{
  actor_name = actor.actor_name;
  actor_type = actor.actor_type;
  dimension_case = actor.dimension_case;
  actor_case = actor.actor_case;
}

char * bicotiActorDescriptor :: GetActorName()
{return actor_name;}

ActorTypes bicotiActorDescriptor :: GetActorType()
{return actor_type;}

DimensionCases bicotiActorDescriptor :: GetActorDimension()
{return dimension_case;}

ActorCases bicotiActorDescriptor :: GetActorCase()
{return actor_case;}



//--------------------bicotiActor----------------------
bicotiEventLoopManager * bicotiActor :: ptr_current_event_loop;

bicotiActor :: bicotiActor( const char * act_name )
{
  if( act_name != NULL ) 
   {actor_name = new char[ strlen( act_name ) + 1 ];
   strcpy( actor_name, act_name );}
  else
   actor_name = NULL;
  
  ptr_homologous = NULL;  
}

bicotiActor :: ~bicotiActor()
{
  if( ptr_homologous != NULL )
    {delete ptr_homologous;
    ptr_homologous = NULL;}

  delete actor_name;
}

bicotiActorDescriptor bicotiActor :: GetActorDescriptor()
{return bicotiActorDescriptor( actor_name, actor_type, dimension_case, actor_case );}

void bicotiActor :: SetHomologous( bicotiHomologous * ptr_homo )
{ptr_homologous = ptr_homo;}


bicotiHomologous * bicotiActor :: GetHomologous()
{return ptr_homologous;}


bicotiEventLoopManager * bicotiActor :: GetCurrentEventLoop()
{
  return ptr_current_event_loop;
}


//------------bicotiHomologousView------------
bicotiHomologous :: ~bicotiHomologous()
{
  ptr_actor->SetHomologous( NULL );
}


void bicotiHomologous :: SetActor( bicotiActor * ptr_source )
{
  ptr_actor = ptr_source;
}

bicotiActor * bicotiHomologous :: GetActor()
{return ptr_actor;}
