#include <source/actor/actor_graphic_2D_field.hpp>


//------------------bicotiActor2DField--------------------
bicotiActorGraphic2DField :: bicotiActorGraphic2DField( char * act_name ) : bicotiActorGraphic2D( act_name )
{
  actor_case = actor_field;
  local_text = new char[1];
  local_text[ 0 ] = '\0';

  frame =  false ;
  bicotiEchoMode echo_mode  = EchoOn ;
  cursor_position = 0;
  max_length = MAX_LENGTH; 
  select_all = false;
}


bicotiActorGraphic2DField :: ~bicotiActorGraphic2DField()
{
  if (local_text != NULL) 
    delete local_text;
}


bool bicotiActorGraphic2DField :: CheckText( const char * new_text )
{
  if( !strcmp( local_text, new_text ) )
    return false;
  else
    {if( local_text != NULL )
      delete local_text;
    local_text = new char[strlen(new_text)+1];
    strcpy( local_text, new_text );
    return true;}
}


void bicotiActorGraphic2DField :: SetText( const char * text )
{
  if (local_text != NULL) delete local_text;
  local_text = new char[strlen(text)+1];
  strcpy(local_text,text);
  if ( ptr_homologous != NULL )
    ((bicotiHomologousGraphic2DField*)ptr_homologous)->SetText( local_text );
}


const char * bicotiActorGraphic2DField :: GetText()
{
  return local_text;
}


void bicotiActorGraphic2DField :: SetFrame( bool set_frame)
{
  frame = set_frame;
  if (ptr_homologous != NULL)
    ((bicotiHomologousGraphic2DField*)ptr_homologous)->SetFrame(frame);
}

void bicotiActorGraphic2DField :: SetEchoMode(  bicotiEchoMode set_echo_mode)
{
  echo_mode = set_echo_mode;
 if (ptr_homologous != NULL)
    ((bicotiHomologousGraphic2DField*)ptr_homologous)->SetEchoMode(echo_mode);
}

void bicotiActorGraphic2DField :: SetCursorPosition( int set_cursor)
{
  cursor_position = set_cursor;
  if (ptr_homologous != NULL)
    ((bicotiHomologousGraphic2DField*)ptr_homologous)->SetCursorPosition(cursor_position);
}

int bicotiActorGraphic2DField :: GetCursorPosition()
{
  if (ptr_homologous != NULL)
    cursor_position = ((bicotiHomologousGraphic2DField*)ptr_homologous)->GetCursorPosition();
  return cursor_position;
}


int bicotiActorGraphic2DField ::GetInitialCursorPosition()
{
  return cursor_position;
}

bool bicotiActorGraphic2DField :: GetFrame()
{
  return frame;
}

bicotiEchoMode bicotiActorGraphic2DField ::GetEchoMode()
{
  return echo_mode;
}

 void bicotiActorGraphic2DField ::  SetMaxLength( int set_max_length)
{
  max_length = set_max_length;
  if (ptr_homologous != NULL)
    ((bicotiHomologousGraphic2DField*)ptr_homologous)->SetMaxLength(cursor_position);
}

int bicotiActorGraphic2DField ::  GetMaxLength()
{
  return max_length;
}

void bicotiActorGraphic2DField :: SelectAll()
{
  select_all = true;
 if (ptr_homologous != NULL)
   ((bicotiHomologousGraphic2DField*)ptr_homologous)->SelectAll();
}

bool  bicotiActorGraphic2DField :: AllSelected()
{
  return select_all;
}

void  bicotiActorGraphic2DField :: Clear()
{
  SetText( "" );
}


//----------------bicotiHomologous2DField-----------------
bicotiHomologousGraphic2DField :: ~bicotiHomologousGraphic2DField()
{}


void bicotiHomologousGraphic2DField ::SetParameters()
{
  SetFrame( (( bicotiActorGraphic2DField *)ptr_actor)->GetFrame()  );
  SetEchoMode( (( bicotiActorGraphic2DField *)ptr_actor)->GetEchoMode()   );
  SetCursorPosition( (( bicotiActorGraphic2DField *)ptr_actor)->GetInitialCursorPosition()   );
  SetMaxLength(((bicotiActorGraphic2DField *)ptr_actor)->GetMaxLength()   );
  if ((( bicotiActorGraphic2DField *)ptr_actor)->AllSelected() ) SelectAll();
}
