#include <source/actor/actor_graphic_2D_scroll_bar.hpp>


//---------------bicotiActorGraphic2DScrollBar---------------
bicotiActorGraphic2DScrollBar :: bicotiActorGraphic2DScrollBar( char * name ) : bicotiActorGraphic2D( name )
{
  min_val = 0;
  max_val = 10;
  current_val = 0;
  line_step = 1;
  page_step = 1;
  vertical = true;
  actor_case = actor_scroll_bar;
}


bicotiActorGraphic2DScrollBar :: ~bicotiActorGraphic2DScrollBar()
{}


bool bicotiActorGraphic2DScrollBar :: CheckScrollBarValue( int val )
{
  if( val != current_val )
    {current_val = val;
    return true;}
  else
    return false;
}


bool bicotiActorGraphic2DScrollBar :: CheckScrollBarRange( int min, int max )
{
  if( ( min != min_val ) || ( max != max_val ) )
    {min_val = min;
    max_val = max;
    return true;}
  else
    return false;
}


bool bicotiActorGraphic2DScrollBar :: CheckScrollBarStep( int ls, int ps )
{
  if( ( ls != line_step ) || ( ps != page_step ) )
    {line_step = ls;
    page_step = ps;
    return true;}
  else
    return false;
}


void bicotiActorGraphic2DScrollBar :: SetMinimum( int min )
{
  if( ptr_homologous == NULL )
    FireScrollBarRangeChanged( this, min, max_val );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetMinimum( min );
}


void bicotiActorGraphic2DScrollBar :: SetMaximum( int max )
{
  if( ptr_homologous == NULL )
    FireScrollBarRangeChanged( this, min_val, max );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetMaximum( max );
}


void bicotiActorGraphic2DScrollBar :: SetRange( int min, int max )
{
  if( ptr_homologous == NULL )
    FireScrollBarRangeChanged( this, min, max );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetRange( min, max );
}


void bicotiActorGraphic2DScrollBar :: SetLineStep( int ls )
{
  if( ptr_homologous == NULL )
    FireScrollBarStepChanged( this, ls, page_step );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetLineStep( ls );
}


void bicotiActorGraphic2DScrollBar :: SetPageStep( int ps )
{
  if( ptr_homologous == NULL )
    FireScrollBarStepChanged( this, line_step, ps );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetPageStep( ps );
}


void bicotiActorGraphic2DScrollBar :: SetValue( int val )
{
  if( ptr_homologous == NULL )
    FireScrollBarValueChanged( this, val );
  else
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetValue( val );
}


void bicotiActorGraphic2DScrollBar :: SetVertical( bool vert )
{
  vertical = vert;
  
  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphic2DScrollBar*)ptr_homologous)->SetVertical( vertical );
}


int bicotiActorGraphic2DScrollBar :: GetMinimum()
{
  return min_val;
}


int bicotiActorGraphic2DScrollBar :: GetMaximum()
{
  return max_val;
}


int bicotiActorGraphic2DScrollBar :: GetLineStep()
{
  return line_step;
}


int bicotiActorGraphic2DScrollBar :: GetPageStep()
{
  return page_step;
}


int bicotiActorGraphic2DScrollBar :: GetValue()
{
  return current_val;
}


bool bicotiActorGraphic2DScrollBar :: GetVertical()
{
  return vertical;
}



bicotiHomologousGraphic2DScrollBar :: ~bicotiHomologousGraphic2DScrollBar()
{}
