#include <source/actor/actor_graphic_menu.hpp>


//-------------------bicotiActorGraphicMenu---------------------
bicotiActorGraphicMenu :: bicotiActorGraphicMenu( char * act_name ) : bicotiActorGraphic( act_name )
{
  dimension_case = _menu;
}


bicotiActorGraphicMenu :: ~bicotiActorGraphicMenu()
{
}


int bicotiActorGraphicMenu :: current_id = 0;


int bicotiActorGraphicMenu :: AddItem( char * item )
{
  elements_list.push_back( InternalStructure( current_id, false, item ) );
  
  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphicMenu*)ptr_homologous)->AddItem( current_id, item );

  return( current_id++ );
}


int bicotiActorGraphicMenu :: AddItem( char * item , bicotiActorGraphicMenuPopup * pupm )
{
  elements_list.push_back( InternalStructure( current_id, false, item, pupm ) );
  
  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphicMenu*)ptr_homologous)->AddItem( current_id, item, pupm );
  
  return( current_id++ );
}


int bicotiActorGraphicMenu :: AddSeparator()
{
  elements_list.push_back( InternalStructure( current_id ) );

  if( ptr_homologous != NULL )
    ((bicotiHomologousGraphicMenu*)ptr_homologous)->AddSeparator();

  return( current_id++ );
}


bool bicotiActorGraphicMenu :: CheckItem( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );
  
  return( iter != elements_list.end() );
}


void bicotiActorGraphicMenu :: RemoveElement( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );

  if( iter == elements_list.end() )
    throw bicotiException( "bicotiActorGraphicMenu", "RemoveElement", 4); 
  else
    {elements_list.erase( iter );
    if( ptr_homologous != NULL ) 
      ((bicotiHomologousGraphicMenu*)ptr_homologous)->RemoveElement( item_id );}
}


bool bicotiActorGraphicMenu :: IsItem( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );
  
  if( iter == elements_list.end() )
    throw bicotiException( "bicotiActorGraphicMenu", "IsItem", 4);
  else
    return( !( (*iter).is_separator ) );
}


bool bicotiActorGraphicMenu :: IsSeparator( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );
  
  if( iter == elements_list.end() )
    throw bicotiException( "bicotiActorGraphicMenu", "IsSeparator", 4);
  else
    return( (*iter).is_separator );
}


char * bicotiActorGraphicMenu :: GetItem( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );
  
  if( iter == elements_list.end() )
    throw bicotiException( "bicotiActorGraphicMenu", "GetItem", 4); 
  else
    {if( (*iter).is_separator )
      throw bicotiException( "bicotiActorGraphicMenu", "GetItem", 5);
    else
      return( (*iter).item_name );}
}


bicotiActorGraphicMenuPopup * bicotiActorGraphicMenu :: GetPopupForItem( int item_id )
{
  vector< InternalStructure > :: iterator iter;
  iter = find( elements_list.begin(), elements_list.end(), InternalStructure( item_id ) );

  if( iter == elements_list.end() )
    throw bicotiException( "bicotiActorGraphicMenu", "GetPopupForItem", 4);
  else
    {if( (*iter).is_separator )
      throw bicotiException( "bicotiActorGraphicMenu", "GetPopupForItem", 5);
    else
      return( (*iter).ptr_popup );}
}


int bicotiActorGraphicMenu :: GetElementsNumber()
{
  return( current_id );
}


bool bicotiActorGraphicMenu :: CheckItem( char * item )
{
  bool salida = false;
  
  for( int i = 0; ( ( i < elements_list.size() ) && !salida ); i++ )
    if( !(elements_list[ i ].is_separator) )
      salida = !strcmp( elements_list[ i ].item_name, item );
  
  return salida;
}


bicotiActorGraphicMenu :: InternalStructure :: InternalStructure( int i, bool is_sep, char * item_n, bicotiActorGraphicMenuPopup * ptr_pop )
{
  id = i;
  is_separator = is_sep;
  item_name = item_n;
  ptr_popup = ptr_pop;
}


bool bicotiActorGraphicMenu :: InternalStructure :: operator==( const InternalStructure& str ) const
{
  return( id == str.id );
}



//----------------bicotiHomologousGraphicMenu-------------------
bicotiHomologousGraphicMenu :: ~bicotiHomologousGraphicMenu()
{}
