//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################

#ifndef _bicoti_coordinate
#define _bicoti_coordinate


#include <source/coordinate/coordinate_2D.hpp>
#include <source/coordinate/coordinate_3D.hpp>
#include <source/coordinate/coordinate_vectorial_static.hpp>



//***************************DECLARATIONS**********************************
//---------------------------CoordCompar-----------------------------------
template< class CoordType >
class CoordinateCompareCriterion
{
public:
  CoordinateCompareCriterion();
  unsigned component;
  bool operator()( const CoordType&, const CoordType& );
};


//*************************IMPLEMENTATIONS*********************************
//---------------------------CoordCompar-----------------------------------
template< class CoordType >
CoordinateCompareCriterion< CoordType > :: CoordinateCompareCriterion()
{
  component = 0;
};


template< class CoordType >
bool CoordinateCompareCriterion< CoordType > :: operator()( const CoordType& coord_1, const CoordType& coord_2 )
{
  CoordType coord_aux_1, coord_aux_2;

  coord_aux_1 = coord_1;
  coord_aux_2 = coord_2;

  return( coord_aux_1( component ) < coord_aux_2( component ) );
};


#endif
