//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _dexel_basic
#define _dexel_basic


#include <source/transformation/transformation.hpp>
#include <source/math_algorithms/math_algorithms.hpp>



//-----------------Declarations------------------
//------Dexel------
template< class PixelType >
class bicotiDexel
{
protected:
  bicotiImageImplementation< PixelType > * ptr_image_imp;

public:
  virtual ~bicotiDexel(){};
  void SetImageImplementation( bicotiImageImplementation< PixelType > * );

  virtual void UpdateImageImplementation()=0;
  virtual void UpdateDexel()=0;
};


template< class PixelType >
void bicotiDexel< PixelType > :: SetImageImplementation( bicotiImageImplementation< PixelType > *  ptr_imp )
{
  ptr_image_imp = ptr_imp;
};



#endif
