#include <source/dexel/dexel_labeling/connectivity_labeling_strategy_3D_6N.hpp>


//******************************IMPLEMENTATIONS**********************************
//-----------------------bicotiConnectivityLabelingStrategy3D6N---------------------------
bicotiConnectivityLabelingStrategy3D6N :: bicotiConnectivityLabelingStrategy3D6N()
{
  next_label_available = 1;
  ptr_matrix = NULL;
};


void bicotiConnectivityLabelingStrategy3D6N :: operator() ( bicotiCoordinate< INTEGER > coord )
{
#ifdef TOTAL_CHECK
  if( coord.GetDimension() != 3 )
    throw bicotiException( "bicotiConnectivityLabelingStrategy3D6N", "operator()", 2 );
#endif

  current_x1 = (int)coord( 0 );
  current_x2 = (int)coord( 1 );
  current_x3 = (int)coord( 2 );

  if( InImage( current_x1 - 1, current_x2, current_x3) && InImage( current_x1, current_x2 - 1, current_x3) && 
      InImage( current_x1, current_x2, current_x3 - 1) )
    {if( (*ptr_matrix)( current_x1, current_x2, current_x3 - 1) == 0 )
      {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3) == 0 )
	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
	  InsertInTable( next_label_available );
	  next_label_available++;}
	else
	  (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);}
      else
      	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )	
	  (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);
	else
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);
	  SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1 - 1, current_x2, current_x3) );}}}
    else
      {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3) == 0 )
	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	  (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2, current_x3 - 1);
	else
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);
	  SetEquivalence( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3),(*ptr_matrix)( current_x1, current_x2, current_x3 - 1) );}}
      else
	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);
	  SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1, current_x2, current_x3 - 1) );}
	else
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);	    
	  SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1, current_x2, current_x3 - 1) );
	  SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1 - 1, current_x2, current_x3) );
	  }}}}
  else
    {if ( InImage( current_x1 - 1, current_x2, current_x3) && InImage( current_x1, current_x2 - 1, current_x3) )
      {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3 ) == 0 )
	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
	  InsertInTable( next_label_available );
	  next_label_available++;}
	else
          (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);}
      else
	{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	  (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);
	else
	  {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);
	  SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1 - 1, current_x2, current_x3) );}}}
    else
      {if ( InImage( current_x1 - 1, current_x2, current_x3) && InImage( current_x1, current_x2, current_x3 - 1) )
	{if( (*ptr_matrix)( current_x1, current_x2, current_x3 - 1) == 0 )
	  {if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	    {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
	    InsertInTable( next_label_available );
	    next_label_available++;}
	  else
	    (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);}
	else
	  {if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
	    (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2, current_x3 - 1);
	  else
	    {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);
	    SetEquivalence( (*ptr_matrix)( current_x1, current_x2, current_x3 - 1),(*ptr_matrix)( current_x1 - 1, current_x2, current_x3) );}}}
      else
	{if ( InImage( current_x1, current_x2 - 1, current_x3) && InImage( current_x1, current_x2, current_x3 - 1) )
	  {if( (*ptr_matrix)( current_x1, current_x2, current_x3 - 1) == 0 )
	    {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3) == 0 )
	      {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
	      InsertInTable( next_label_available );
	      next_label_available++;}
	    else
	      (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2, current_x3 - 1);}
	  else
	    {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3) == 0 )
	      (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2, current_x3 - 1);
	    else
	      {(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);
	      SetEquivalence( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3),(*ptr_matrix)( current_x1, current_x2, current_x3 - 1) );}}}
	else
	  {if( InImage( current_x1, current_x2, current_x3 - 1) )
	    {if( (*ptr_matrix)( current_x1, current_x2, current_x3 - 1) == 0 )
	      {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
	      InsertInTable( next_label_available );
	      next_label_available++;}
	    else
	      (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2, current_x3 - 1);}
	  else
	    {if( InImage( current_x1, current_x2 - 1, current_x3) )
	      {if( (*ptr_matrix)( current_x1, current_x2 - 1, current_x3) == 0 )
		{(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
		InsertInTable( next_label_available );
		next_label_available++;}
	      else
		(*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1, current_x2 - 1, current_x3);}
	    else
	      {if( InImage( current_x1 - 1, current_x2, current_x3) )
		{if( (*ptr_matrix)( current_x1 - 1, current_x2, current_x3) == 0 )
		  {(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
		  InsertInTable( next_label_available );
		  next_label_available++;}
		else
		  (*ptr_matrix)( current_x1, current_x2, current_x3) = (*ptr_matrix)( current_x1 - 1, current_x2, current_x3);}
	      else
		{(*ptr_matrix)( current_x1, current_x2, current_x3) = next_label_available;
		InsertInTable( next_label_available );
		next_label_available++;}}}}}}}
}; 
