//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _connectivity_labeling_strategy_basic
#define _connectivity_labeling_strategy_basic



#include <source/dexel/dexel_basic.hpp>



//********************************DECLARATIONS***********************************
//----------------------bicotiConnectivityLabelingStrategy-----------------------
class bicotiConnectivityLabelingStrategy
{
protected:
  vector< vector< unsigned > > * ptr_equiv_table;

  unsigned next_label_available;

  void SetEquivalence( unsigned& , unsigned& );
  void InsertInTable( unsigned& );

public:
  virtual void Initiate( bicotiImageDescriptor *, vector< vector < unsigned > > * ) = 0;

  virtual void operator() ( bicotiCoordinate< INTEGER > ) = 0;

  virtual bicotiMatrix< unsigned > * CreateResult() = 0;
};



//-----------------bicotiConnectivityLabelingStrategy2D--------------------------
class bicotiConnectivityLabelingStrategy2D : public bicotiConnectivityLabelingStrategy
{
protected:
  unsigned x1_size, x2_size;
  int current_x1, current_x2;

  bool InImage( int , int );

  bicotiMatrix2D< unsigned > * ptr_matrix;

public:
  void Initiate( bicotiImageDescriptor *, vector< vector < unsigned > > * );
  
  virtual void operator() ( bicotiCoordinate< INTEGER > ) = 0;

  bicotiMatrix< unsigned > * CreateResult();
};



//------------------------bicotiConnectivityLabelingStrategy3D----------------------------
class bicotiConnectivityLabelingStrategy3D : public bicotiConnectivityLabelingStrategy
{
protected:
  unsigned x1_size, x2_size, x3_size;
  int current_x1, current_x2, current_x3;

  bool InImage( int , int , int );

  bicotiMatrix3D< unsigned > * ptr_matrix;

public:
  void Initiate( bicotiImageDescriptor *, vector< vector < unsigned > > * );
  
  virtual void operator() ( bicotiCoordinate< INTEGER > ) = 0;

  bicotiMatrix< unsigned > * CreateResult();
};






#endif
