//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _pixel_labeling_criterion_single_range
#define _pixel_labeling_criterion_single_range



#include <source/dexel/dexel_labeling/pixel_labeling_criterion_basic.hpp>



//********************************DECLARATIONS************************************
//-------------------bicotiPixelLabelingCriterionSingleRange----------------------
template< class PixelType >
class bicotiPixelLabelingCriterionSingleRange :  public bicotiPixelLabelingCriterionSingle< PixelType >
{
private:
  PixelType start_pixel, end_pixel;

public:
  bicotiPixelLabelingCriterionSingleRange( PixelType, PixelType, bool = true );
  bool operator() ( PixelType );
};



//******************************IMPLEMENTATIONS**********************************
//-------------------bicotiPixelLabelingCriterionSingleRange---------------------
template< class PixelType >
bicotiPixelLabelingCriterionSingleRange< PixelType > :: bicotiPixelLabelingCriterionSingleRange( PixelType start_pix, PixelType end_pix, bool val_dir )
{
   if( start_pix > end_pix )
    throw bicotiException( "bicotiPixelLabelingCriterionSingleRange", "Constructor", 4 );

  start_pixel = start_pix;
  end_pixel = end_pix;
  direct = val_dir;
};


template< class PixelType >
inline bool bicotiPixelLabelingCriterionSingleRange< PixelType > :: operator() ( PixelType value )
{
  if( direct )
    return( ( start_pixel <= value ) && ( value <= end_pixel ) );
  else
    return( !(( start_pixel <= value ) && ( value <= end_pixel )) );
};


#endif
