#ifndef _bicoti_homologous_factory_basic
#define _bicoti_homologous_factory_basic


#include <source/actor/actor.hpp>


//--------------------DECLARATIONS---------------------
//---------------bicotiHomologousFactory---------------

/**
 * Clase base para los homologous factory
 *
 * Crea los homlogos de los actores. Existe una especializacin para cada biblioteca grfica
 */
class bicotiHomologousFactory
{
public:
  /**
   * Crea el homlogo de un actor
   *
   *@param ptr_actor actor cuyo homolgo se quiere crear
   */
  virtual void CreateHomologous( bicotiActor * ptr_actor )=0;
  
  /**
   * Crea homlogos de actores recursivamente
   *
   * Crea el homlogo para un actor y para cada uno de sus hijos. Este mtodo existe por practicidad.
   *@param ptr_actor actor cuyo homolgo se quiere crear
   */
  virtual void RecursiveCreateHomologous( bicotiActor * ptr_actor )=0;
};


#endif
