#ifndef _actor_image_2D_hsv_int_qt
#define _actor_image_2D_hsv_int_qt

#include <source/image/image_2D_vectorial.hpp>
#include <source/image/actor_image_2D.hpp>
#include <source/event_loop_manager/qt/pixel_converter_qt.hpp>
#include <source/event_loop_manager/qt/event_loop_manager_qt.hpp>



//**********************DECLARATIONS**************************
/** Fachada para implementacin QT de bicotiActorImage para pixel tipo hsv integer */
class bicotiActorImage2DHSVIntQT : public bicotiActorImage2D< bicotiHSV< unsigned int, REAL >, bicotiHomologousFactoryQT< bicotiHSV< unsigned int, REAL >, bicotiPixelConverterHSVInt2QRGB >, bicotiEventLoopManagerQT, bicotiPixelConverterHSVInt2QRGB >, public bicotiImage2DVectorial< bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > > , unsigned int, bicotiPixelConverterHSVInt2RGBA , bicotiHSV< unsigned int, REAL >, bicotiHSV< REAL, unsigned int >  >
{
public:

  /** 
   * Constructor 
   *  
   *@param x0_size ancho de la imagen
   *@param x1_size altura de la imagen
   *@param name nombre del actor
   */
  bicotiActorImage2DHSVIntQT( unsigned x0_size, unsigned x1_size, char * name );  
  
  /** Constructor por defecto */
  bicotiActorImage2DHSVIntQT();
  
  /** Destructor */
  ~bicotiActorImage2DHSVIntQT();
 
  /** 
   * Devuelve un puntero al actor
   *
   *@returns puntero al actor
   */
  bicotiActorGraphic2DImage< bicotiHSV< unsigned int, REAL > > * GetActor();
  
  /**
   * Construye una implementacin de imagen
   *
   *@param x0_size ancho de la imagen 
   *@param x1_size altura de la imagen
   */
  void BuildImplementation( unsigned, unsigned );
  
  /** Construye una fachada de mapper */
  void BuildMapper();
};



#endif
