#ifndef _actor_image_2D_rgb_char_qt
#define _actor_image_2D_rgb_char_qt

#include <source/image/image_2D_vectorial.hpp>
#include <source/image/actor_image_2D.hpp>
#include <source/event_loop_manager/qt/pixel_converter_qt.hpp>
#include <source/event_loop_manager/qt/event_loop_manager_qt.hpp>



//**********************DECLARATIONS**************************

/** Fachada para implementacin QT de bicotiActorImage para pixel tipo rgb char */
class bicotiActorImage2DRGBCharQT : public bicotiActorImage2D< bicotiRGB< unsigned char, REAL >, bicotiHomologousFactoryQT< bicotiRGB< unsigned char, REAL >, bicotiPixelConverterRGBChar2QRGB >, bicotiEventLoopManagerQT, bicotiPixelConverterRGBChar2QRGB >, public bicotiImage2DVectorial< bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > > , unsigned char, bicotiPixelConverterRGBChar2RGBA , bicotiRGB< unsigned char, REAL >, bicotiRGB< REAL, unsigned char >  >
{
public:

 /** 
   * Constructor 
   *
   *@param x0_size ancho de la imagen
   *@param x1_size altura de la imagen
   *@param name nombre del actor
   */
  bicotiActorImage2DRGBCharQT( unsigned, unsigned, char * );
  
  /** Constructor por defecto */
  bicotiActorImage2DRGBCharQT();
 
  /** Destructor */
 ~bicotiActorImage2DRGBCharQT();

  /** 
   * Devuelve un puntero al actor
   *
   *@returns puntero al actor
   */
  bicotiActorGraphic2DImage< bicotiRGB< unsigned char, REAL > > * GetActor();
 
  /**
   * Construye una implementacin de imagen
   *
   *@param x0_size ancho de la imagen 
   *@param x1_size altura de la imagen
   */
  void BuildImplementation( unsigned x0_size, unsigned x1_size );

  /** Construye una fachada de mapper */
  void BuildMapper();
};



#endif
