#ifndef _actor_image_2D_rgb_float_qt
#define _actor_image_2D_rgb_float_qt

#include <source/image/image_2D_vectorial.hpp>
#include <source/image/actor_image_2D.hpp>
#include <source/event_loop_manager/qt/pixel_converter_qt.hpp>
#include <source/event_loop_manager/qt/event_loop_manager_qt.hpp>

//**********************DECLARATIONS**************************

/** Fachada para implementacin QT de bicotiActorImage para pixel tipo rgb float */
class bicotiActorImage2DRGBFloatQT : public bicotiActorImage2D< bicotiRGB< float, REAL >, bicotiHomologousFactoryQT< bicotiRGB< float, REAL >, bicotiPixelConverterRGBFloat2QRGB >, bicotiEventLoopManagerQT, bicotiPixelConverterRGBFloat2QRGB >, public bicotiImage2DVectorial< bicotiActorGraphic2DImage< bicotiRGB< float, REAL > > , float, bicotiPixelConverterRGBFloat2RGBA, bicotiRGB< float, REAL >, bicotiRGB< REAL, float >  >
{
public:
  
  /** 
   * Constructor 
   *
   *@param x0_size ancho de la imagen
   *@param x1_size altura de la imagen
   *@param name nombre del actor
   */
  bicotiActorImage2DRGBFloatQT( unsigned x0_size, unsigned x1_size, char * name );
  
  /** Constructor por defecto */
  bicotiActorImage2DRGBFloatQT();
  
  /** Destructor */
  ~bicotiActorImage2DRGBFloatQT();

  /** 
   * Devuelve un puntero al actor
   *
   *@returns puntero al actor
   */
  bicotiActorGraphic2DImage< bicotiRGB< float, REAL > > * GetActor();
  
  /**
   * Construye una implementacin de imagen
   *
   *@param x0_size ancho de la imagen 
   *@param x1_size altura de la imagen
   */
  void BuildImplementation( unsigned x0_size , unsigned x1_size );
  
  /** Construye una fachada de mapper */
  void BuildMapper();
};



#endif
