#include <source/event_loop_manager/qt/homologous_qt_2D_field.hpp>


//-----------------bicotiQT2DField------------------
bicotiQT2DField :: bicotiQT2DField( QWidget * parent, const char * name ) : QLineEdit(parent, name) 
{
  ptr_actor = NULL;
  connect( this, SIGNAL(returnPressed()), this, SLOT(ReturnPressed()) );
  connect( this, SIGNAL(textChanged( const char * )), this , SLOT(FieldChanged( const char * )) );
}


bicotiQT2DField :: ~bicotiQT2DField()
{
  recreate( NULL, 0, QPoint(  x(),  y() ) , false );
}


void bicotiQT2DField :: SetText( const char * text )
{
  setText( text );
}


void bicotiQT2DField :: FieldChanged( const char * new_text )
{
  ((bicotiActorGraphic2DField*)ptr_actor)->FireFieldChanged( ptr_actor, new_text );
}


void bicotiQT2DField :: ReturnPressed()
{
  ((bicotiActorGraphic2DField*)ptr_actor)->FireReturnPressed( ptr_actor );
}


void  bicotiQT2DField ::SetFrame( bool set_frame)
{
  setFrame(set_frame);
}


void bicotiQT2DField :: SetEchoMode( bicotiEchoMode echo_mode )
{
  
  EchoMode mode;
  switch(echo_mode)
    {
    case EchoOn:{ mode =  Normal;
    break;
    } 
    case EchoOff:{ mode = NoEcho;
    break;
    } 
    case Password:{ mode = Password;
    break;
    } 
    }
  setEchoMode( mode );
}


void bicotiQT2DField :: SetCursorPosition( int cursor_position )
{
  setCursorPosition( cursor_position );
}


int bicotiQT2DField :: GetCursorPosition()
{
  return cursorPosition();
}


void bicotiQT2DField :: SetMaxLength( int set_max_length )
{
  setMaxLength( set_max_length );
}


void bicotiQT2DField :: SelectAll()
{
  selectAll();
}


#define bicotiLocalTemplate
#define bicotiLocalClass bicotiQT2DField
#include <source/event_loop_manager/qt/homologous_qt_graphic.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic2.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.cpp>
