#include <source/event_loop_manager/qt/homologous_qt_2D_file_dialog.hpp>
#include <stdio.h>

//-------------------IMPLEMENTATION--------------------
//-------------------bicotiQT2DFileDialog-------------------
bicotiQT2DFileDialog :: bicotiQT2DFileDialog( QWidget * parent, const char * name ) : QFileDialog( parent, name )
{
  ptr_actor = NULL;
  hide();
  // connect( this, SIGNAL(dirEntered(const char *)), this, SLOT(DirEntered(const char *)) ); VER DirEntered
  connect( this, SIGNAL(fileHighlighted(const char *)), this, SLOT(FileHighlighted(const char *)) );
  connect( this, SIGNAL(fileSelected(const char *)), this, SLOT(FileSelected(const char *)) );
}


bicotiQT2DFileDialog :: ~bicotiQT2DFileDialog()
{
  recreate( NULL, 0, QPoint( x(), y() ), false );
}


void bicotiQT2DFileDialog :: DirEntered( const char * newdir )
{
  // OJO NO FUNCIONA dirEntered ( Bug de QT )
  ((bicotiActorGraphic2DFileDialog*)ptr_actor)->FireFileDialogDirectoryChanged( ptr_actor, newdir );
}


void bicotiQT2DFileDialog :: FileHighlighted( const char * file )
{
  ((bicotiActorGraphic2DFileDialog*)ptr_actor)->FireFileDialogFileHighlighted( ptr_actor, file );
}


void bicotiQT2DFileDialog :: FileSelected( const char * file )
{
  ((bicotiActorGraphic2DFileDialog*)ptr_actor)->FireFileDialogFileSelected( ptr_actor, file );
  QCloseEvent temp;
  closeEvent( &temp );
}


void bicotiQT2DFileDialog :: MousePress( int x, int y ,char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );
}


void bicotiQT2DFileDialog :: MouseRelease( int x, int y, char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );
}


void bicotiQT2DFileDialog :: SetDirectory( const char * direct )
{
  setDir( direct );
  ((bicotiActorGraphic2DFileDialog*)ptr_actor)->FireFileDialogDirectoryChanged( ptr_actor, direct ); // ESTE LINEA VA POR EL BUG en dirEnter
}


void bicotiQT2DFileDialog :: SetFilter( const char * filt )
{
  setFilter( filt );
}


void bicotiQT2DFileDialog :: SetExistingFile( bool mode )
{
  if( mode )
    setMode( QFileDialog :: ExistingFile );
  else
    setMode( QFileDialog :: AnyFile );
}


#define bicotiLocalTemplate
#define bicotiLocalClass bicotiQT2DFileDialog
#include <source/event_loop_manager/qt/homologous_qt_graphic.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.cpp>
