#include <source/event_loop_manager/qt/homologous_qt_2D_push_button.hpp>


//-----------------bicotiQT2DPushButton------------------
bicotiQT2DPushButton :: bicotiQT2DPushButton( QWidget * parent, const char * name ) : QPushButton( parent, name )
{
  ptr_actor = NULL;
  left_pressed_already = false;
  connect( this, SIGNAL(clicked()), this, SLOT(Clicked()) );
}

bicotiQT2DPushButton :: ~bicotiQT2DPushButton()
{
  recreate( NULL, 0, QPoint( x(), y() ) , false );
}

void bicotiQT2DPushButton :: MousePress( int x, int y ,char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );

  if ( mask & button_left ) left_pressed_already = true;
}

void bicotiQT2DPushButton :: MouseRelease( int x, int y, char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );

  if ( ( mask & button_left ) && left_pressed_already )
    {left_pressed_already = false;
    Click();}
}

void bicotiQT2DPushButton :: Clicked()
{
  ((bicotiActorGraphic2DPushButton*)ptr_actor)->FirePushButtonClicked( ptr_actor );
}

void bicotiQT2DPushButton :: Click()
{
  animateClick();
}

void bicotiQT2DPushButton :: SetText( char * text )
{
  setText( text );
}


#define bicotiLocalTemplate
#define bicotiLocalClass bicotiQT2DPushButton
#include <source/event_loop_manager/qt/homologous_qt_graphic.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.cpp>
