#include <source/event_loop_manager/qt/homologous_qt_2D_scroll_bar.hpp>


//-----------------bicotiQT2DField------------------
bicotiQT2DScrollBar ::  bicotiQT2DScrollBar( QWidget * parent, const char * name ) : QScrollBar( parent, name )
{
  ptr_actor = NULL;
  connect( this, SIGNAL(valueChanged(int)), this, SLOT(ValueChanged(int)) );
  connect( this, SIGNAL(sliderPressed()), this, SLOT(SliderPressed()) );
  connect( this, SIGNAL(sliderReleased()), this, SLOT(SliderReleased()) );
}


bicotiQT2DScrollBar ::  ~bicotiQT2DScrollBar()
{
  recreate( NULL, 0, QPoint(  x(),  y() ) , false );
}


void bicotiQT2DScrollBar :: MousePress( int x, int y ,char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );
}


void bicotiQT2DScrollBar :: MouseRelease( int x, int y, char mask )
{
  QPoint local_pos( x, y );
  QPoint global_pos = mapToGlobal( local_pos );
  QCursor :: setPos( global_pos );
}


void bicotiQT2DScrollBar ::  ValueChanged( int val )
{
  ((bicotiActorGraphic2DScrollBar*)ptr_actor)->FireScrollBarValueChanged( ptr_actor, val );
}


void bicotiQT2DScrollBar ::  SliderPressed()
{
  ((bicotiActorGraphic2DScrollBar*)ptr_actor)->FireScrollBarSliderPressed( ptr_actor, ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetValue() );
}


void bicotiQT2DScrollBar ::  SliderReleased()
{
  ((bicotiActorGraphic2DScrollBar*)ptr_actor)->FireScrollBarSliderReleased( ptr_actor, ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetValue() );
}


void bicotiQT2DScrollBar :: SetMinimum( int min )
{
  setRange( min, ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetMaximum() );
}


void bicotiQT2DScrollBar :: SetMaximum( int max )
{
  setRange( ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetMinimum(), max );
}


void bicotiQT2DScrollBar :: SetRange( int min, int max )
{
  setRange( min, max );
}


void bicotiQT2DScrollBar :: SetLineStep( int ls )
{
  setSteps( ls, ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetPageStep() );
}


void bicotiQT2DScrollBar :: SetPageStep( int ps )
{
  setSteps( ((bicotiActorGraphic2DScrollBar*)ptr_actor)->GetLineStep(), ps );
}


void bicotiQT2DScrollBar :: SetValue( int val )
{
  setValue( val );
}


void bicotiQT2DScrollBar :: SetVertical( bool vert )
{
  if( vert )
    setOrientation( QScrollBar :: Vertical );
  else
    setOrientation( QScrollBar :: Horizontal );
}


#define bicotiLocalTemplate
#define bicotiLocalClass bicotiQT2DScrollBar
#include <source/event_loop_manager/qt/homologous_qt_graphic.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.cpp>
