#ifndef _bicoti_homologous_qt_2D_scroll_bar
#define _bicoti_homologous_qt_2D_scroll_bar


#include <qscrollbar.h>
#include <source/actor/actor_graphic_2D_scroll_bar.hpp>
#include <source/event_loop_manager/qt/homologous_qt_caster.hpp>


//-----------------bicotiQT2DScrollBar------------------

/** Implementacin QT de bicotiHomologousGraphic2DScrollBar */
class bicotiQT2DScrollBar : public QScrollBar,  public bicotiHomologousGraphic2DScrollBar
{
private:

  /**@#-*/
Q_OBJECT
/**@#+*/

public /**@#-*/ slots /**@#+*/:

/** 
 * Slot: Se ejecuta cuando cambia el valor del scrollbar
 *
 *@param val valor del scrollbar 
 */
  void ValueChanged( int val );
 
  /**
   * Slot: Se ejecuta cuando se presiona el ratn sobre deslizador
   *
   */
  void SliderPressed();
  
  /**
   *Slot: Se ejecuta cuando se libera el ratn sobre el deslizador
   *
   *
   */
  void SliderReleased();
 
public:
  /** 
   * Constructor 
   *
   *@param parent widget padre 
   *@param name  nombre del widget
   */
  bicotiQT2DScrollBar( QWidget * parent=0, const char * name=0 );
  
  /** Destructor */
  ~bicotiQT2DScrollBar();
  
  void SetMinimum( int );
  void SetMaximum( int );
  void SetRange( int, int );
  void SetLineStep( int );
  void SetPageStep( int );
  void SetValue( int );
  void SetVertical( bool );

  void MousePress( int, int, char );
  void MouseRelease( int, int, char );

#include <source/event_loop_manager/qt/homologous_qt_graphic.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_2D.hpp>
};


#endif
