//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _frame_basic
#define _frame_basic


#include <source/frame/matrix.hpp>


 
//*************************DECLARATIONS****************************
//-------------------------bicotiFrame-----------------------------
template< class PixelType > 
class bicotiFrame 
{ 
protected: 
  int frame_size; 
  bool is_done; 
  PixelType * ptr_current; 
   
public: 
  virtual ~bicotiFrame(){}; 
  
  virtual void First() = 0; 
  virtual void Next() = 0; 
  
  bool IsDone(); 
  PixelType& CurrentPixel(); 
 
  int GetFrameSize(); 
}; 


 

//***********************IMPLEMENTATIONS***************************
//-------------------------bicotiFrame-----------------------------
template< class PixelType > 
int bicotiFrame< PixelType > :: GetFrameSize() 
{ 
  return( frame_size ); 
}; 
 
 
template< class PixelType > 
inline bool bicotiFrame< PixelType > :: IsDone() 
{ 
  return( is_done ); 
}; 
 
 
template< class PixelType > 
inline PixelType& bicotiFrame< PixelType > :: CurrentPixel() 
{ 
  return( *ptr_current ); 
}; 


#endif     
