//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _matrix_basic
#define _matrix_basic



#include <source/coordinate/coordinate.hpp>



//*******************************DECLARATIONS**********************************
//-------------------------------bicotiMatrix----------------------------------
template< class PixelType >
class bicotiMatrixIterator;


template< class PixelType >
class bicotiMatrix
{
public:
  virtual bicotiMatrixIterator< PixelType > * CreateIterator() = 0;
};



//---------------------------bicotiMatrixIterator------------------------------
template< class PixelType >
class bicotiMatrixIterator
{
protected :
  bool is_done;
  
public:
  virtual void First()=0;
  bool IsDone();
  virtual void Next()=0;
  
  virtual PixelType& CurrentPixel()=0;
  virtual bicotiCoordinate< INTEGER > CurrentCoordinate()=0;
};




//*****************************IMPLEMENTATIONS*********************************
//---------------------------bicotiMatrixIterator------------------------------
template< class PixelType >
bool bicotiMatrixIterator< PixelType > :: IsDone()
{
  return( is_done );
};



#endif   
