#include <source/image/image_2D_array_float.hpp>

//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayFloat :: bicotiImage2DArrayFloat(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();
  
  ptr_implementation = new bicotiImageImplementation2DArray< float >( 0, x0_size, x1_size, 1, single );
};


bicotiImage2DArrayFloat :: bicotiImage2DArrayFloat()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< float >( 0, 0, 0, 1, single );
};


bicotiImage2DArrayFloat :: ~bicotiImage2DArrayFloat()
{
  DeleteMe();
};


void bicotiImage2DArrayFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  ptr_implementation = new bicotiImageImplementation2DArray< float >( 0, x0_size, x1_size, 1, single );
};


void bicotiImage2DArrayFloat :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< float , bicotiPixelConverterFloat2RGBA >( GetImplementation() );
}

