#include <source/image/image_2D_array_int.hpp>



//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayInt :: bicotiImage2DArrayInt(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< unsigned int >( 0, x0_size, x1_size, 1, single);
}


bicotiImage2DArrayInt :: bicotiImage2DArrayInt()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation2DArray< unsigned int >( 0, 0, 0, 1, single);
}


bicotiImage2DArrayInt :: ~bicotiImage2DArrayInt()
{
  DeleteMe();
}


void bicotiImage2DArrayInt :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();
  
  ptr_implementation = new bicotiImageImplementation2DArray< unsigned int >( 0, x0_size, x1_size, 1, single );
}


void bicotiImage2DArrayInt :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< unsigned int , bicotiPixelConverterInt2RGBA >( GetImplementation() );
}

