#include <source/image/image_2D_array_rgb_char.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayRGBChar :: bicotiImage2DArrayRGBChar(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, 1, vectorial);
};


bicotiImage2DArrayRGBChar :: bicotiImage2DArrayRGBChar()
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< unsigned char, REAL > >( def_pix, 0, 0, 1, vectorial);
};


bicotiImage2DArrayRGBChar :: ~bicotiImage2DArrayRGBChar()
{
  DeleteMe();
};


void bicotiImage2DArrayRGBChar :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, 1, vectorial );
};


void bicotiImage2DArrayRGBChar :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< bicotiRGB< unsigned char, REAL >, bicotiPixelConverterRGBChar2RGBA >( GetImplementation() );
}

