#include <source/image/image_2D_array_rgb_float.hpp>



//********************IMPLEMENTATIONS*************************
bicotiImage2DArrayRGBFloat :: bicotiImage2DArrayRGBFloat( unsigned x0_size, unsigned x1_size )
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< float > >( def_pix, x0_size, x1_size, 1, vectorial);
};


bicotiImage2DArrayRGBFloat :: bicotiImage2DArrayRGBFloat()
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< float > >( def_pix, 0, 0, 1, vectorial );
};


bicotiImage2DArrayRGBFloat :: ~bicotiImage2DArrayRGBFloat()
{
  DeleteMe();
};


void bicotiImage2DArrayRGBFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  bicotiRGB< float > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation2DArray< bicotiRGB< float > >( def_pix, x0_size, x1_size, 1, vectorial );
};


void bicotiImage2DArrayRGBFloat :: BuildMapper()
{
  if( ptr_mapper != NULL )
    delete ptr_mapper;
  
  ptr_mapper = new bicotiMapperFacade2D< bicotiRGB< float >, bicotiPixelConverterRGBFloat2RGBA >( GetImplementation() );
}
