//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_3D_linear_rgb_char
#define _image_3D_linear_rgb_char



#include <source/image/image_3D_vectorial.hpp



//**********************DECLARATIONS**************************
class bicotiImage3DLinearRGBChar : public bicotiImage3DVectorial< bicotiImageImplementation3DLinear< bicotiRGB< unsigned char, REAL > >, unsigned char, bicotiRGB< unsigned char, REAL >, bicotiRGB< REAL, unsigned char >  >
{
public:
  bicotiImage3DLinearRGBChar( unsigned, unsigned, unsigned );
  bicotiImage3DLinearRGBChar();
  ~bicotiImage3DLinearRGBChar();

  void BuildImplementation( unsigned, unsigned, unsigned );
};




//********************IMPLEMENTATIONS*************************
bicotiImage3DLinearRGBChar :: bicotiImage3DLinearRGBChar(unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial);
};


bicotiImage3DLinearRGBChar :: bicotiImage3DLinearRGBChar()
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< unsigned char, REAL > >( def_pix, 0, 0, 0, 1, vectorial);
};


bicotiImage3DLinearRGBChar :: ~bicotiImage3DLinearRGBChar()
{
  DeleteMe();
};


void bicotiImage3DLinearRGBChar :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial );
};



#endif
