//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_3D_vectorial 
#define _image_3D_vectorial 

 
 
#include <source/image/image_3D.hpp>
 
 
 
//**********************DECLARATIONS************************** 
template< class ImageType, class ColorType, class PixelType, class PrecisionType = PixelType > 
class bicotiImage3DVectorial : public bicotiImage3D< ImageType, ColorType, PixelType, PrecisionType > 
{ 
public: 
  void BuildProperty(); 
  bicotiPropertyFacade< bicotiCoordinate3D< INTEGER >, ColorType, PixelType, PrecisionType >* CreateProperty(); 
   
  void BuildNeighbourFilter(); 
  bicotiNeighbourFilterFacade3D< PixelType, PrecisionType >* CreateNeighbourFilter(); 
 
  void BuildDexel(); 
  bicotiDexelFacade3DVectorial< PixelType > * GetDexel();  
  bicotiDexelFacade3DVectorial< PixelType > * CreateDexel();
}; 
 

 
 
//********************IMPLEMENTATIONS************************* 
template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
void bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: BuildProperty() 
{ 
  if( ptr_property != NULL ) 
    delete ptr_property; 
   
  ptr_property = new bicotiPropertyFacadeVectorial< bicotiCoordinate3D< INTEGER >, ColorType ,PixelType ,PrecisionType >( ptr_implementation ); 
}; 
 
 
template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
bicotiPropertyFacade< bicotiCoordinate3D< INTEGER >, ColorType, PixelType, PrecisionType >* bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: CreateProperty() 
{ 
  return ( new bicotiPropertyFacadeVectorial< bicotiCoordinate3D< INTEGER >, ColorType, PixelType, PrecisionType >( ptr_implementation )); 
}; 
 
 
template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
void bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: BuildNeighbourFilter() 
{ 
  if( ptr_neighbour_filter != NULL ) 
    delete ptr_neighbour_filter; 
 
  ptr_neighbour_filter = new bicotiNeighbourFilterFacade3DVectorial< ColorType, PixelType, PrecisionType > ( ptr_implementation ); 
}; 
 
 
template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
bicotiNeighbourFilterFacade3D< PixelType, PrecisionType >* bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: CreateNeighbourFilter() 
{ 
  return( new bicotiNeighbourFilterFacade3DVectorial< ColorType, PixelType, PrecisionType > ( ptr_implementation ) ); 
}; 
 
 
template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
void bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: BuildDexel() 
{ 
  if( ptr_dexel != NULL ) 
    delete ptr_dexel; 
 
  ptr_dexel = new bicotiDexelFacade3DVectorial< PixelType >( ptr_implementation ); 
 
}; 
 

template< class ImageType, class ColorType, class PixelType, class PrecisionType > 
bicotiDexelFacade3DVectorial< PixelType > * bicotiImage3DVectorial< ImageType, ColorType, PixelType, PrecisionType > :: CreateDexel() 
{ 
  return( new bicotiDexelFacade3DVectorial< PixelType >( ptr_implementation ) ); 
}; 
 


#endif   
