//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_extrapolation_strategy_2D_constant
#define _image_extrapolation_strategy_2D_constant


#include <source/image_implementation/image_extrapolation_strategy_2D.hpp>

 
 
//***********************************DECLARATIONS************************************
//---------------------bicotiImageExtrapolationStrategy2DConstant--------------------
template< class PixelType >  
class bicotiImageExtrapolationStrategy2DConstant : public bicotiImageExtrapolationStrategy2D< PixelType > 
{ 
private: 
  PixelType default_pixel; 
  
public: 
  bicotiImageExtrapolationStrategy2DConstant( PixelType ); 
  ~bicotiImageExtrapolationStrategy2DConstant(){}; 
  
  PixelType operator() ( int, int ); 
}; 
 
 


//*********************************IMPLEMENTATIONS**********************************
//-------------------bicotiImageExtrapolationStrategy2DConstant---------------------
template< class PixelType >  
bicotiImageExtrapolationStrategy2DConstant< PixelType > :: bicotiImageExtrapolationStrategy2DConstant( PixelType def_pix ) 
{ 
  default_pixel = def_pix; 
}; 
 

template< class PixelType >  
PixelType bicotiImageExtrapolationStrategy2DConstant< PixelType > :: operator() ( int x_0, int x_1 ) 
{ 
  if ( ( 0 <= x_0 ) && ( 0 <= x_1 ) && ( x_0 < ptr_image->GetX0Size() ) && ( x_1 < ptr_image->GetX1Size() ) ) 
    return ( ptr_image->GetPixel( x_0, x_1 ) ); 
  else 
    return ( default_pixel ); 
};       



#endif
