//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _image_extrapolation_strategy_2D_equal
#define _image_extrapolation_strategy_2D_equal



#include <source/image_implementation/image_extrapolation_strategy_2D.hpp>
 

 
//***********************************DECLARATIONS***********************************
//----------------------bicotiImageExtrapolationStrategy2D--------------------------
template< class PixelType > 
class bicotiImageExtrapolationStrategy2DEqual : public bicotiImageExtrapolationStrategy2D< PixelType > 
{ 
 public: 
  bicotiImageExtrapolationStrategy2DEqual(){}; 
  ~bicotiImageExtrapolationStrategy2DEqual(){}; 
 
  PixelType operator() ( int, int ); 
}; 
 
 

 
//*********************************IMPLEMENTATIONS**********************************
//------------------------bicotiImageExtrapolationStrategy2D------------------------
template< class PixelType >  
PixelType bicotiImageExtrapolationStrategy2DEqual< PixelType > :: operator() ( int x_0, int x_1 ) 
{ 
  if ( ( 0 <= x_0 ) && ( 0 <= x_1 ) && ( x_0 < ptr_image->GetX0Size() ) && ( x_1 < ptr_image->GetX1Size() ) ) 
    return ( ptr_image->GetPixel( x_0, x_1 ) ); 
  else 
    {if ( x_0 < 0 ) 
      {if ( x_1 < 0 ) 
	return ( ptr_image->GetPixel( 0, 0 ) ); 
      else 
	{if ( x_1 >= ptr_image->GetX1Size() ) 
	  return ( ptr_image->GetPixel( 0, ptr_image->GetX1Size() - 1 ) ); 
	else 
	  return ( ptr_image->GetPixel( 0, x_1 ) );}} 
    else 
      {if ( x_0 >= ptr_image->GetX0Size() ) 
	{if ( x_1 < 0 ) 
	  return ( ptr_image->GetPixel( ptr_image->GetX0Size() - 1, 0 ) ); 
	else 
	  {if ( x_1 >= ptr_image->GetX1Size() ) 
	    return ( ptr_image->GetPixel( ptr_image->GetX0Size() - 1, ptr_image->GetX1Size() - 1 ) ); 
	  else 
	    return ( ptr_image->GetPixel( ptr_image->GetX0Size() - 1, x_1 ) );}} 
      else 
	{if ( x_1 < 0 ) 
	  return ( ptr_image->GetPixel( x_0, 0 ) ); 
	else 
	  return ( ptr_image->GetPixel( x_0, ptr_image->GetX1Size() - 1 ) );}}} 
}; 


#endif
