//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _image_extrapolation_strategy_3D 
#define _image_extrapolation_strategy_3D


 
#include <source/image_implementation/image_extrapolation_strategy_basic.hpp>



//**********************************DECLARATIONS************************************
//-----------------------bicotiImageExtrapolationStrategy3D-------------------------
template< class PixelType >  
class bicotiImageImplementation3D;
  
 
template< class PixelType >   
class bicotiImageExtrapolationStrategy3D : public bicotiImageExtrapolationStrategy< PixelType >  
{  
protected:  
  bicotiImageImplementation3D< PixelType > * ptr_image;  
    
public:  
  virtual ~bicotiImageExtrapolationStrategy3D(){};  
  void SetImplementation( bicotiImageImplementation3D< PixelType > * );  
  virtual PixelType operator() ( int, int, int ) = 0;  
};  
  



//***********************************IMPLEMENTATIONS****************************************
//--------------------------bicotiImageExtrapolationStrategy3D------------------------------
template< class PixelType >   
void bicotiImageExtrapolationStrategy3D< PixelType > :: SetImplementation( bicotiImageImplementation3D< PixelType > * ptr_ima )  
{  
  ptr_image = ptr_ima;  
};  



#endif     
