//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _image_pixel_interpolator_2D
#define _image_pixel_interpolator_2D



#include <source/image_pixel_interpolator/image_pixel_interpolator_basic.hpp>



//************************DECLARATIONS****************************
//----------------bicotiImagePixelInterpolator2D------------------

template< class PixelType >  
class bicotiImagePixelInterpolator2D : public bicotiImagePixelInterpolator< PixelType >
{ 
protected:
  bicotiImageImplementation2D< PixelType > * ptr_image_imp; 

  bool InImage( bicotiCoordinate2D< REAL >& );  
  bool InBorder( bicotiCoordinate2D< REAL >& ); 

public:
  void SetImageImplementation( bicotiImageImplementation< PixelType >* );
};  




//***********************IMPLEMENTATIONS**************************
//---------------bicotiImagePixelInterpolator2D-------------------
template< class PixelType >  
void bicotiImagePixelInterpolator2D< PixelType > :: SetImageImplementation( bicotiImageImplementation< PixelType >* ptr_image)  
{
  ptr_image_imp = (bicotiImageImplementation2D< PixelType >*)ptr_image;
}


template< class PixelType >  
inline bool bicotiImagePixelInterpolator2D< PixelType > :: InImage( bicotiCoordinate2D< REAL >& coord )  
{  
  return( ( 0 <= coord.X0() ) && ( coord.X0() <=  ptr_image_imp->GetX0Size() - 1 ) && 
	  ( 0 <= coord.X1() ) && ( coord.X1() <=  ptr_image_imp->GetX1Size() - 1 ) );
};



template< class PixelType >  
inline bool bicotiImagePixelInterpolator2D< PixelType > :: InBorder( bicotiCoordinate2D< REAL >& coord )  
{  
  return( ( (int)coord.X0() == ( ptr_image_imp->GetX0Size() - 1 ) ) || 
	  ( (int)coord.X1() == ( ptr_image_imp->GetX1Size() - 1 ) ) );
};


#endif        
