#include <source/interaction/interaction_geometry.hpp>
#include <stl.h>

//------------------IMPLEMENTATIONS--------------------
//-----------------bicotiEventGeometry-----------------
bicotiEventGeometry :: bicotiEventGeometry( int x_in, int y_in )
{
  x = x_in;
  y = y_in;
}


bicotiEventGeometry :: bicotiEventGeometry()
{
  x = 0;
  y = 0;
}

  
int bicotiEventGeometry :: GetX() const
{
  return x;
}


int bicotiEventGeometry :: GetY() const
{
  return y;
}




//-----------bicotiInteractionSourceGeometry-----------
void bicotiInteractionSourceGeometry :: AddListenerGeometry( bicotiListenerGeometry * ptr_listener )
{listener_container.push_back( ptr_listener );}


void bicotiInteractionSourceGeometry :: RemoveListenerGeometry( bicotiListenerGeometry * ptr_listener )
{
  vector< bicotiListenerGeometry * > :: iterator iter;
  iter = find( listener_container.begin(), listener_container.end(), ptr_listener );
  listener_container.erase( iter );
}


void bicotiInteractionSourceGeometry :: FireActorResized( bicotiActor * ptr_act, int w, int h )
{
  if ( CheckSize( w, h ) )
    {bicotiEventGeometry event( w, h );
    for( int i=0; i<listener_container.size(); i++ )
      listener_container[i]->ActorResized( ptr_act, event );}
}


void bicotiInteractionSourceGeometry :: FireActorMoved( bicotiActor * ptr_act, int x_in, int y_in )
{
  if ( CheckPosition( x_in, y_in ) )
    {bicotiEventGeometry event( x_in, y_in );
    for( int i=0; i<listener_container.size(); i++ )
      listener_container[i]->ActorMoved( ptr_act, event );}
}
