#include <source/interaction/interaction_mouse.hpp>

//------------------IMPLEMENTATTIONS-------------------
//------------------bicotiEventMouse-------------------
bicotiEventMouse :: bicotiEventMouse( int x_in, int y_in, char mask )
{
  x = x_in;
  y = y_in;
  button_mask = mask;
}
  
int bicotiEventMouse :: GetX() const
{return x;}

int bicotiEventMouse :: GetY() const
{return y;}

char bicotiEventMouse :: GetButtonMask() const
{return button_mask;}

bool bicotiEventMouse :: IsLeftButton() const
{return (button_mask & button_left);}

bool bicotiEventMouse :: IsMiddleButton() const
{return (button_mask & button_middle);}

bool bicotiEventMouse :: IsRightButton() const
{return (button_mask & button_right);}



//-------------bicotiInteractionSourceMouse------------
void bicotiInteractionSourceMouse :: AddListenerMouse( bicotiListenerMouse * ptr_listener )
{listener_mouse.push_back( ptr_listener );}

void bicotiInteractionSourceMouse :: RemoveListenerMouse( bicotiListenerMouse * ptr_listener )
{
  vector< bicotiListenerMouse * > :: iterator iter;
  iter = find( listener_mouse.begin(), listener_mouse.end(), ptr_listener );
  listener_mouse.erase( iter );
}

void bicotiInteractionSourceMouse :: FireMousePressed( bicotiActor * ptr_act, int x_in, int y_in, char mask )
{
  bicotiEventMouse event( x_in, y_in, mask );

  for( int i=0; i<listener_mouse.size(); i++ )
    listener_mouse[i]->MousePressed( ptr_act, event );
}

void bicotiInteractionSourceMouse :: FireMouseReleased( bicotiActor * ptr_act, int x_in, int y_in, char mask )
{
  bicotiEventMouse event( x_in, y_in, mask );
  
  for( int i=0; i<listener_mouse.size(); i++ )
    listener_mouse[i]->MouseReleased( ptr_act, event );
}


