#ifndef _mapper_tiff
#define _mapper_tiff


#include <source/mapper/mapper_basic.hpp>


//------------------bicotiMappertiff-------------------
//------------------Declarations-----------------------


/**
 * Clase base para mappers TIFF
 *
 *@see bicotiMapperTIFFSGI
 */
template< class PixelType >
class bicotiMapperTIFF : public bicotiMapper< PixelType >
{
protected:

  int compression_algorithm;
  int color_space;
public:

  /** Constructor
   *
   * Fija color_space = 2
   * Fija compression_algorithm = 1
   */
  bicotiMapperTIFF();

  /**
   * Fija algorithmo de compresin
   *
   *@param value 1 (sin compresin) 5 (LZW)  
   */
  void SetCompression( int value);

  /** 
   * Fija Espacio de color
   *
   *@param value 0 gris ( mnimo es blanco); 1  gris ( mnimo es negro); 2 RGB;
3 Colormap RGB (no implementado)
  */
  void SetColorSpace( int value ); 
};

//--------------------------bicotiMapperTiff-------------------------
//--------------------------Implementation--------------------------

template< class PixelType >
bicotiMapperTIFF< PixelType >::bicotiMapperTIFF()
{
  compression_algorithm = 1;
  color_space = 2;
}

template< class PixelType >
void bicotiMapperTIFF< PixelType > :: SetCompression( int value )
{
  compression_algorithm = value;
}

template< class PixelType >
void bicotiMapperTIFF< PixelType > :: SetColorSpace(int value )
{
  color_space = value;
}

#endif
