//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _neighbour_function_maximum
#define _neighbour_function_maximum


#include <source/neighbour_filter/neighbour_function_basic.hpp>

 

//**********************DECALARATIONS******************************
//---------------bicotiNeighbourFunctionMaximumSingle--------------
template< class PixelType > 
class bicotiNeighbourFunctionMaximumSingle : public bicotiNeighbourFunction< PixelType > 
{ 
public : 
  PixelType operator()( bicotiFrame< PixelType >* );  
}; 
 
 

//-------------bicotiNeighbourFunctionMaximumVectorial-------------
template< class PixelType > 
class bicotiNeighbourFunctionMaximumVectorial : public bicotiNeighbourFunction< PixelType > 
{ 
public : 
  PixelType operator()( bicotiFrame< PixelType >* );  
}; 
 
 
 
//**********************IMPLEMENTATIONS****************************
//------------bicotiNeighbourFunctionMaximumSingle-----------------
template< class PixelType > 
PixelType bicotiNeighbourFunctionMaximumSingle< PixelType > :: operator()( bicotiFrame< PixelType >* ptr_frame ) 
{ 
  ptr_frame->First(); 
  PixelType max_value = ptr_frame->CurrentPixel(); 
  ptr_frame->Next(); 
   
  while ( !ptr_frame->IsDone() )  
    {if( ptr_frame->CurrentPixel() > max_value ) 
      max_value = ptr_frame->CurrentPixel(); 
    ptr_frame->Next();}; 
   
  return( max_value ); 
}; 
 

 
//-----------bicotiNeighbourFunctionMaximumVectorial---------------
template< class PixelType > 
PixelType bicotiNeighbourFunctionMaximumVectorial< PixelType > :: operator()( bicotiFrame< PixelType >* ptr_frame ) 
{ 
  unsigned index;  
 
  ptr_frame->First(); 
  PixelType max_value=( ptr_frame->CurrentPixel() ); 
  ptr_frame->Next(); 
   
  while ( !ptr_frame->IsDone() )  
    {for( index = 0; index < max_value.GetColorsNumber(); index++ ) 
      {if( ( ptr_frame->CurrentPixel() )( index ) > max_value( index ) ) 
	max_value( index ) = ( ptr_frame->CurrentPixel() )( index );} 
    ptr_frame->Next();} 
   
  return( max_value ); 
};         



#endif
