//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _neighbour_function_median
#define _neighbour_function_median




#include <source/neighbour_filter/neighbour_function_basic.hpp>



//**********************DECALARATIONS******************************
//-------------bicotiNeighbourFunctionMedianSingle-----------------
template< class PixelType >
class bicotiNeighbourFunctionMedianSingle : public bicotiNeighbourFunction< PixelType >
{
public :
  PixelType operator()( bicotiFrame< PixelType >* ); 
};



//------------bicotiNeighbourFunctionMedianVectorial---------------
template< class ColorType, class PixelType >
class bicotiNeighbourFunctionMedianVectorial : public bicotiNeighbourFunction< PixelType >
{
public :
  PixelType operator()( bicotiFrame< PixelType >* ); 
};




//**********************IMPLEMENTATIONS****************************
//------------bicotiNeighbourFunctionMedianSingle------------------
template< class PixelType >
PixelType bicotiNeighbourFunctionMedianSingle< PixelType > :: operator()( bicotiFrame< PixelType >* ptr_frame )
{
  vector< PixelType > buffer;
  
  for( ptr_frame->First(); !ptr_frame->IsDone() ; ptr_frame->Next() )
    buffer.push_back( ptr_frame->CurrentPixel() );
  
  vector< PixelType > :: iterator first = buffer.begin();
  vector< PixelType > :: iterator last = buffer.end();
  sort( first, last );
  
  return( buffer[ ( buffer.size() - 1) / 2 ] );
};



//----------bicotiNeighbourFunctionMedianVectorial-----------------
template< class ColorType, class PixelType >
PixelType bicotiNeighbourFunctionMedianVectorial< ColorType, PixelType > :: operator()( bicotiFrame< PixelType >* ptr_frame )
{
  unsigned index;

  ptr_frame->First();
  PixelType median = ptr_frame->CurrentPixel();

  vector< ColorType > buffer;
  vector< ColorType > :: iterator first;
  vector< ColorType > :: iterator last;
  
  for( ptr_frame->First(); !ptr_frame->IsDone() ; ptr_frame->Next() )
    buffer.push_back( ( ptr_frame->CurrentPixel() )( 0 ) );
  
  first = buffer.begin();
  last = buffer.end();
  sort( first, last );
  median( 0 ) = buffer[ ( buffer.size() - 1 ) / 2 ];
  
  for( unsigned col_index = 1; col_index < median.GetColorsNumber(); col_index++ )
    {for( index = 0, ptr_frame->First(); !ptr_frame->IsDone(); index++, ptr_frame->Next() )
      buffer[ index ]= ( ptr_frame->CurrentPixel())( col_index );
    
    first = buffer.begin();
    last = buffer.end();
    sort( first, last );
    median( col_index ) = buffer[ ( buffer.size() - 1 ) / 2 ];}
  
  return( median );
};         



#endif
