//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _operator_multiple
#define _operator_multiple



#include <source/operator_multiple/operator_multiple_basic.hpp>



//***********************DECLARATIONS******************************
//-----------------bicotiOperatorMultipleFacade--------------------
template<class PixelType>
class bicotiOperatorMultipleFacade
{
protected:
  bicotiOperatorMultiple< PixelType > oper_mult;

public: 
  bicotiOperatorMultipleFacade( bicotiImageImplementation< PixelType > * );

  void Append( bicotiImageImplementation< PixelType > * );
  void Reset();

  void Addition();
  void Product();
  void Subtraction();
  void Division( PixelType, PixelType );
  void Maximum();
  void Minimum();
};




//***********************DECLARATIONS******************************
//-----------------bicotiOperatorMultipleFacade--------------------
template<class PixelType>
bicotiOperatorMultipleFacade< PixelType > :: bicotiOperatorMultipleFacade( bicotiImageImplementation< PixelType > * ptr_ima_imp )
{
  oper_mult.Append( ptr_ima_imp );
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Append( bicotiImageImplementation< PixelType > * ptr_ima_imp )
{
  oper_mult.Append( ptr_ima_imp );
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Reset()
{
  oper_mult.Reset( 1 );
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Addition()
{
  bicotiPixelOperatorBinaryAddition< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinaryAddition< PixelType >;

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Product()
{
  bicotiPixelOperatorBinaryProduct< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinaryProduct< PixelType >;

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Subtraction()
{
  bicotiPixelOperatorBinarySubtraction< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinarySubtraction< PixelType >;

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Division( PixelType zero, PixelType infinite )
{
  bicotiPixelOperatorBinaryDivision< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinaryDivision< PixelType >( zero, infinite );

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Maximum()
{
  bicotiPixelOperatorBinaryMaximization< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinaryMaximization< PixelType >;

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};


template<class PixelType>
void bicotiOperatorMultipleFacade< PixelType > :: Minimum()
{
  bicotiPixelOperatorBinaryMinimization< PixelType > * ptr_oper;
  ptr_oper = new bicotiPixelOperatorBinaryMinimization< PixelType >;

  oper_mult.Apply( ptr_oper );

  delete ptr_oper;
};  



#endif
