//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _pixel_attribute_selector_basic
#define _pixel_attribute_selector_basic



#include <source/pixel/pixel_implementation.hpp>



//***********************DECLARATIONS******************************
//----------------bicotiPixelAttributeSelector---------------------
template< class AttributeType, class PixelType = AttributeType >
class bicotiPixelAttributeSelector
{
public:
  virtual AttributeType operator() ( PixelType )=0;
  virtual PixelType Inverse( PixelType, AttributeType )=0;
};


//---------------bicotiPixelAttributeSelectorNone------------------
template< class AttributeType >
class bicotiPixelAttributeSelectorNone : public bicotiPixelAttributeSelector< AttributeType >
{
public:
  AttributeType operator() ( AttributeType );
  AttributeType Inverse( AttributeType, AttributeType );
};


//----------------bicotiPixelAttributeSelectorRound-----------------
template< class AttributeType >
class bicotiPixelAttributeSelectorRound : public bicotiPixelAttributeSelector< AttributeType >
{
public:
  AttributeType operator() ( AttributeType );
  AttributeType Inverse( AttributeType, AttributeType );
};




//*********************IMPLEMENTATIONS*****************************
//-------------bicotiPixelAttributeSelectorNone--------------------
template< class AttributeType >
inline AttributeType bicotiPixelAttributeSelectorNone< AttributeType > :: operator() ( AttributeType pix_val )
{
  return ( pix_val );
};


template< class AttributeType >
inline AttributeType bicotiPixelAttributeSelectorNone< AttributeType > :: Inverse( AttributeType pix_val , AttributeType col_val )
{
  return ( col_val );
};



//------------bicotiPixelAttributeSelectorRound--------------------
template< class AttributeType >
inline AttributeType bicotiPixelAttributeSelectorRound< AttributeType > :: operator() ( AttributeType pix_val )
{
  //  return ( (AttributeType)rint( pix_val ) );
  return ( (AttributeType)floor( pix_val + .5 ) );
};


template< class AttributeType >
inline AttributeType bicotiPixelAttributeSelectorRound< AttributeType > :: Inverse( AttributeType pix_val , AttributeType col_val )
{
  return ( col_val );
};



#endif
