//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_attribute_selector_rgb
#define _pixel_attribute_selector_rgb


#include <source/pixel/pixel_attribute_selector_basic.hpp>



//***********************DECLARATIONS******************************
//---------------bicotiPixelAttributeSelectorColorRed--------------
template< class AttributeType >
class bicotiPixelAttributeSelectorColorRed : public bicotiPixelAttributeSelector< AttributeType, bicotiRGB< AttributeType > >
{
public:
  AttributeType operator() ( bicotiRGB< AttributeType > );
  bicotiRGB< AttributeType > Inverse( bicotiRGB< AttributeType >, AttributeType );
};


//--------------bicotiPixelAttributeSelectorColorGreen-------------
template< class AttributeType >
class bicotiPixelAttributeSelectorColorGreen : public bicotiPixelAttributeSelector< AttributeType ,bicotiRGB< AttributeType > >
{
public:
  AttributeType operator() ( bicotiRGB< AttributeType > );
  bicotiRGB< AttributeType > Inverse( bicotiRGB< AttributeType >, AttributeType );
};


//----------------bicotiPixelAttributeSelectorColorBlue------------
template< class AttributeType >
class bicotiPixelAttributeSelectorColorBlue : public bicotiPixelAttributeSelector< AttributeType, bicotiRGB< AttributeType > >
{
public:
  AttributeType operator() ( bicotiRGB< AttributeType > );
  bicotiRGB< AttributeType > Inverse( bicotiRGB< AttributeType >, AttributeType );
};




//**********************IMPLEMENTATIONS****************************
//------------bicotiPixelAttributeSelectorColorRed-----------------
template< class AttributeType >
AttributeType bicotiPixelAttributeSelectorColorRed< AttributeType > :: operator() ( bicotiRGB< AttributeType > pix_val )
{
  return ( pix_val.Red() );
};


template< class AttributeType >
bicotiRGB< AttributeType > bicotiPixelAttributeSelectorColorRed< AttributeType > :: Inverse( bicotiRGB< AttributeType > pix_val, AttributeType col_val )
{
  pix_val.Red() = col_val;
  return ( pix_val );
};


//------------bicotiPixelAttributeSelectorColorGreen---------------
template< class AttributeType >
AttributeType bicotiPixelAttributeSelectorColorGreen< AttributeType > :: operator() ( bicotiRGB< AttributeType > pix_val)
{
  return ( pix_val.Green() );
};


template< class AttributeType >
bicotiRGB< AttributeType > bicotiPixelAttributeSelectorColorGreen< AttributeType > :: Inverse( bicotiRGB< AttributeType > pix_val, AttributeType col_val )
{
  pix_val.Green() = col_val;
  return ( pix_val );
};


//-------------bicotiPixelAttributeSelectorColorBlue---------------
template< class AttributeType >
AttributeType bicotiPixelAttributeSelectorColorBlue< AttributeType > :: operator() ( bicotiRGB< AttributeType > pix_val )
{
  return ( pix_val.Blue() );
};


template< class AttributeType >
bicotiRGB< AttributeType > bicotiPixelAttributeSelectorColorBlue< AttributeType > :: Inverse( bicotiRGB< AttributeType > pix_val, AttributeType col_val )
{
  pix_val.Blue() = col_val;
  return ( pix_val );
};         

#endif
