//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_binary_minimization
#define _pixel_operator_binary_minimization

#include <source/pixel/pixel_operator_binary_basic.hpp>



//***********************DECLARATIONS******************************
//-------------bicotiPixelOperatorBinaryMinimization---------------
template< class PixelType >
class bicotiPixelOperatorBinaryMinimization : public bicotiPixelOperatorBinary< PixelType >
{
public:
  PixelType operator() ( PixelType, PixelType );
};



//*********************IMPLEMENTATIONS*****************************
//------------bicotiPixelOperatorBinaryMinimization----------------
template< class PixelType >
inline PixelType bicotiPixelOperatorBinaryMinimization< PixelType > :: operator() ( PixelType pix_1, PixelType pix_2)
{
  if ( pix_1 <= pix_2 )
    return( pix_1 );
  else
    return( pix_2 );
};  

#endif
