//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_constant
#define _pixel_operator_unary_constant

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//--------------------------Product--------------------------------
template< class PixelType >
class bicotiPixelOperatorUnaryConstant : public bicotiPixelOperatorUnary< PixelType >
{
private:
  PixelType value;

public:
  bicotiPixelOperatorUnaryConstant(){};
  bicotiPixelOperatorUnaryConstant( PixelType );
  
  PixelType& Pixel();

  PixelType operator() ( PixelType );
};



//**********************IMPLEMENTATIONS****************************
//---------------------------Product-------------------------------
template< class PixelType >
bicotiPixelOperatorUnaryConstant< PixelType > :: bicotiPixelOperatorUnaryConstant( PixelType pix_value )
{
  value = pix_value;
};


template<class PixelType> 
inline PixelType& bicotiPixelOperatorUnaryConstant<PixelType> :: Pixel()
{
  return ( value );
};


template<class PixelType> 
inline PixelType bicotiPixelOperatorUnaryConstant<PixelType> :: operator() ( PixelType pix_val )
{
  return ( value );

#endif
};  
