//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_segmentation
#define _pixel_operator_unary_segmentation

#include <source/pixel/pixel_operator_unary_basic.hpp>



//***********************DECLARATIONS******************************
//-----------------------Segmentation------------------------------
template< class ColorType >
class bicotiPixelOperatorUnarySegmentation : public bicotiPixelOperatorUnary< ColorType >
{
private:
  ColorType threshold_value;
  ColorType lower_value;
  ColorType upper_value;

public:
  bicotiPixelOperatorUnarySegmentation( ColorType, ColorType, ColorType );
  bicotiPixelOperatorUnarySegmentation(){};

  ColorType& LowerValue();
  ColorType& UpperValue();
  ColorType& ThresholdValue();

  ColorType operator() ( ColorType );
};



//**********************IMPLEMENTATIONS****************************
//------------------------Segmentation-----------------------------
template< class ColorType >
bicotiPixelOperatorUnarySegmentation< ColorType > :: bicotiPixelOperatorUnarySegmentation( ColorType the_value, ColorType low_value, ColorType upp_value )
{
  threshold_value = the_value;
  lower_value = low_value;
  upper_value = upp_value;
};


template< class ColorType >
ColorType& bicotiPixelOperatorUnarySegmentation< ColorType > :: LowerValue()
{
  return( lower_value );
};


template< class ColorType >
ColorType& bicotiPixelOperatorUnarySegmentation< ColorType > :: UpperValue()
{
  return( upper_value );
};


template< class ColorType >
ColorType& bicotiPixelOperatorUnarySegmentation< ColorType > :: ThresholdValue()
{
  return( threshold_value );
};


template< class ColorType >
ColorType bicotiPixelOperatorUnarySegmentation< ColorType > :: operator() ( ColorType pix_value )
{
  if ( pix_value < threshold_value )
    return ( lower_value );
  else
    return ( upper_value );
};        

#endif
