//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _transformation_basic
#define _transformation_basic



#include <source/pixel/pixel.hpp>
#include <source/image_pixel_interpolator/image_pixel_interpolator.hpp>



//*************************DECLARATION*****************************
//----------------------bicotiTransformation-----------------------
template< class PixelSource, class PixelTarget >
class bicotiTransformation
{
protected:
  bicotiImageImplementation< PixelSource > * ptr_real_image;
  bicotiImageImplementation< PixelTarget > * ptr_transformed_image;

public:
  virtual void Transform() = 0;
  virtual void Antitransform() = 0;

  void SetImplementations( bicotiImageImplementation< PixelTarget > *, bicotiImageImplementation< PixelSource> * );
};




//***********************IMPLEMENTATIONS***************************
//---------------------bicotiTransformation------------------------
template< class PixelSource, class PixelTarget >
void bicotiTransformation< PixelSource, PixelTarget > :: SetImplementations( bicotiImageImplementation< PixelTarget > * ptr_ima_dest, bicotiImageImplementation< PixelSource > * ptr_ima_src )
{
  unsigned index;
  bicotiImageDescriptor * ptr_desc_src, * ptr_desc_dest;
  
  ptr_desc_src = ptr_ima_src->CreateImageDescriptor();
  ptr_desc_dest = ptr_ima_dest->CreateImageDescriptor();
  
  if ( ( ptr_desc_src->GetDimension() ) != ( ptr_desc_dest->GetDimension() ) )
    {delete ptr_desc_src;
    delete ptr_desc_dest;
    throw bicotiException( "bicotiTransformation", "SetImplementations", 3 );}
  
  delete ptr_desc_src;
  delete ptr_desc_dest;
  
  ptr_real_image = ptr_ima_src;
  ptr_transformed_image = ptr_ima_dest;
};




#endif     
