//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################



#ifndef _transformation_rgb_hsv
#define _transformation_rgb_hsv



#include <source/transformation/transformation_basic.hpp>



//************************DECLARATION******************************
//------------------bicotiTransformationRgbHsv---------------------
template< class ColorSource, class ColorTarget = ColorSource, class PrecisionSource = ColorSource, class PrecisionTarget = ColorTarget >
class bicotiTransformationRgbHsv : public bicotiTransformation< bicotiRGB< ColorSource, PrecisionSource >, bicotiHSV< ColorTarget, PrecisionTarget > >
{
public:
  bicotiTransformationRgbHsv( bicotiImageImplementation< bicotiHSV< ColorTarget, PrecisionTarget > > *, bicotiImageImplementation< bicotiRGB< ColorSource, PrecisionSource > > * );
  bicotiTransformationRgbHsv();

  void Transform();
  void Antitransform();
};




//***********************IMPLEMENTATIONS***************************
//-----------------bicotiTransformationRgbHsv----------------------
template< class ColorSource, class ColorTarget, class PrecisionSource, class PrecisionTarget >
bicotiTransformationRgbHsv< ColorSource, ColorTarget, PrecisionSource, PrecisionTarget > :: bicotiTransformationRgbHsv( bicotiImageImplementation< bicotiHSV< ColorTarget, PrecisionTarget > > * ptr_dest, bicotiImageImplementation< bicotiRGB< ColorSource, PrecisionSource > > * ptr_src)
{
  SetImplementations( ptr_dest, ptr_src );
};


template< class ColorSource, class ColorTarget, class PrecisionSource, class PrecisionTarget >
bicotiTransformationRgbHsv< ColorSource, ColorTarget, PrecisionSource, PrecisionTarget > :: bicotiTransformationRgbHsv() {};


template< class ColorSource, class ColorTarget, class PrecisionSource, class PrecisionTarget >
void bicotiTransformationRgbHsv< ColorSource, ColorTarget, PrecisionSource, PrecisionTarget > :: Transform()
{
  bicotiImageIterator< bicotiRGB< ColorSource, PrecisionSource > > * ptr_iter_src;
  bicotiImageIterator< bicotiHSV< ColorTarget, PrecisionTarget > > * ptr_iter_dest;

  bicotiImageDescriptor * ptr_desc_src;
  ptr_desc_src = ptr_real_image->CreateImageDescriptor();
  ptr_transformed_image->Resize( ptr_desc_src );
  delete ptr_desc_src;
  
  ptr_iter_src = ptr_real_image->CreateIterator();
  ptr_iter_dest = ptr_transformed_image->CreateIterator();

  bicotiPixelTransformationRGBToHSV< ColorSource, ColorTarget, PrecisionSource, PrecisionTarget > pix_trans;
  
  for( ptr_iter_src->First(), ptr_iter_dest->First(); !ptr_iter_src->IsDone(); (*ptr_iter_src)++, (*ptr_iter_dest)++ )
    (**ptr_iter_dest) = pix_trans( **ptr_iter_src );
  
  delete ptr_iter_src;
  delete ptr_iter_dest;
};



template< class ColorSource, class ColorTarget, class PrecisionSource, class PrecisionTarget >
void bicotiTransformationRgbHsv< ColorSource, ColorTarget, PrecisionSource, PrecisionTarget > :: Antitransform()
{
  bicotiImageIterator< bicotiRGB< ColorSource, PrecisionSource > > * ptr_iter_src;
  bicotiImageIterator< bicotiHSV< ColorTarget, PrecisionTarget > > * ptr_iter_dest;
  
  bicotiImageDescriptor * ptr_desc_dest;
  ptr_desc_dest = ptr_transformed_image->CreateImageDescriptor();
  ptr_real_image->Resize( ptr_desc_dest );
  delete ptr_desc_dest;
  
  ptr_iter_src = ptr_real_image->CreateIterator();
  ptr_iter_dest = ptr_transformed_image->CreateIterator();

  bicotiPixelTransformationHSVToRGB< ColorTarget, ColorSource, PrecisionSource, PrecisionTarget > pix_trans;
  
  for( ptr_iter_src->First(), ptr_iter_dest->First(); !ptr_iter_src->IsDone(); (*ptr_iter_src)++, (*ptr_iter_dest)++ )
    (**ptr_iter_src) = pix_trans( **ptr_iter_dest );
  
  delete ptr_iter_src;
  delete ptr_iter_dest;
};



#endif   
